<?php
/**
 * Use this script if you want to import multiple address in one go
 * Usage: populate the stores array with each of your address's and run the script
 */

// include common file
include_once './includes/config.inc.php';
// your google api key
// get one here: http://code.google.com/apis/maps/signup.html
$google_api_key = 'ABQIAAAAyeYxDXjOZeSl8P0ID3NRshT2yXp_ZAY8_ufC3CFXhHIE1NvwkxQNID4BIKXpGWFm65tzPUPH4VEerA';
// current region
// check the official documentation to change region
// http://code.google.com/apis/maps/documentation/v3/services.html#CountryCodes
// requires a ccTLD (county code top-level domain)
// for a list of ccTLD's visit: http://en.wikipedia.org/wiki/CcTLD
$region = 'uk';

// insert the stores you want to save here
$stores = array(
	array(
		'name'=>'Store 1',
		'address'=>'LA1'
	),
	array(
		'name'=>'Store 2',
		'address'=>'BL6'
	),
);

// connect to database
$db = db_connect();
$errors = array();

// import each store
foreach($stores as $k=>$v) {
	// geocode address
	$tmp = file_get_contents("http://maps.google.com/maps/geo?q=".urlencode($v['address'])."&gl={$region}&output=xml&sensor=false&key={$google_api_key}");
	$xml = XML2Array($tmp);
	// lookup successful
	if($xml['Response']['Status']['code']=='200') {
		// get latitude/longitude
		$coords = explode(',', $xml['Response']['Placemark']['Point']['coordinates']);
		// if valid
		if(isset($coords[0]) && isset($coords[1])) {
			// build data
			$data = array(
				'name'=>$v['name'],
				'address'=>$v['address'],
				'latitude'=>$coords[1],
				'longitude'=>$coords[0]
			);
			// insert store
			if( !$db->insert('stores',$data) ) {
				$errors[] = 'There was a problem inserting a store: '.$v['name'].', '.$v['address'];
			}
		}
	} else {
		$errors[] = 'Address Not Found: '.$v['name'].', '.$v['address'];
	}
}


/**
 * Converts XML string to an array
 * http://uk.php.net/manual/en/function.simplexml-load-string.php
 * @param string $xml
 * @param bool $recursive
 * @return array
 */
function XML2Array( $xml , $recursive = false ) {
    if( ! $recursive ){
		$array = simplexml_load_string ( $xml ) ;
    } else {
        $array = $xml ;
    }

    $newArray = array () ;
    $array = ( array ) $array ;
    foreach ( $array as $key => $value ) {
        $value = ( array ) $value ;
        if ( isset ( $value [ 0 ] ) ) {
            $newArray [ $key ] = trim ( $value [ 0 ] ) ;
        } else {
            $newArray [ $key ] = XML2Array ( $value , true ) ;
        }
    }
    return $newArray ;
}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
	<title>Import Stores</title>
	<link rel="stylesheet" type="text/css" href="./css/style.css" media="all" />
</head>
<body>
	<div id="wrapper">
		<div id="header">
			<h1>Import</h1>
		</div>
		<div id="main">
			<h2>Import</h2>

			<?php if(isset($errors) && !empty($errors)): ?>
			<ul class="flash_bad">
				<?php foreach($errors as $k=>$v): ?>
				<li><?php echo $v; ?></li>
				<?php endforeach; ?>
			</ul>
			<?php else: ?>
			<p class="flash_good">Success: All the Stores were added</p>
			<?php endif; ?>

		</div>
	</div>
</body>
</html>