<?php
// includes
include_once './includes/config.inc.php';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
	<title>Store Locator - Features</title>
	<link rel="stylesheet" type="text/css" href="<?php echo ROOT_URL; ?>css/style.css" media="all" />
</head>
<body id="features">
	<div id="wrapper">
		<div id="header">
			<h1>Store Locator</h1>
			<?php include ROOT."templates/nav.inc.php"; ?>
		</div>

		<div id="main">
			<h2>Features</h2>
			
			<h3>New V2 Features</h3>
			<ul>
				<li>Displays Map on front page by default</li>
				<li>User can submit Stores that must be 'approved' by Admin users before they are found via search</li>
				<li>Admin User is notified by email that a new Store has been added for approval</li>
				<li>Map Markers are now clickable with extra information</li>
				<li>Store details now include:
					<ul style="margin-bottom:0px;">
						<li>Telephone</li>
						<li>Email</li>
						<li>Website</li>
						<li>Description</li>
						<li>Thumbnail Image</li>
					</ul>
				</li>
				<li>Uploaded Images are automatically resized to correct size</li>
			</ul>

			<h3>Front End</h3>
			<ul>
				<li>Locate nearby Stores</li>
				<li>Integrated Google Map</li>
				<li>Search by address and/or postcode</li>
				<li>jQuery library</li>
				<li>Uses Ajax to submit form and populate Map without page refresh</li>
				<li>Easy to integrate</li>
				<li>Source Code fully documented and explained</li>
				<li>Easy to setup - enter your database info and paths and you're ready to go</li>
			</ul>
			
			<h3>Back End</h3>
			<ul>
				<li>Password protected admin panel</li>
				<li>List all Stores in database</li>
				<li>Add/edit/delete Stores</li>
				<li>Integrated Google Map to see where the Stores are located</li>
				<li>Easy to setup - enter your database info and paths and you're ready to go</li>
			</ul>

			<h3>Screenshots</h3>
			<div class="gallery">

				<a href="./imgs/screenshots/6-Store-locator.png">
					<img src="./imgs/screenshots/6-Store-locator-thumb.png" alt="Main Store Locator" />
				</a>

				<a href="./imgs/screenshots/1-Login.png">
					<img src="./imgs/screenshots/1-Login-thumb.png" alt="Login Screen" />
				</a>

				<a href="./imgs/screenshots/2-Main-stores-page.png">
					<img src="./imgs/screenshots/2-Main-stores-page-thumb.png" alt="Admin Main Stores" />
				</a>

				<a href="./imgs/screenshots/3-Add-store-1.png">
					<img src="./imgs/screenshots/3-Add-store-1-thumb.png" alt="Admin Add Store 1" />
				</a>

				<a href="./imgs/screenshots/4-Add-store-2.png">
					<img src="./imgs/screenshots/4-Add-store-2-thumb.png" alt="Admin Add Store 2" />
				</a>

				<a href="./imgs/screenshots/5-Edit-store.png">
					<img src="./imgs/screenshots/5-Edit-store-thumb.png" alt="Admin Edit Stores" />
				</a>

			</div>

		</div>
	</div>
<?php include ROOT."templates/footer.inc.php"; ?>
</body>
</html>