<?php
// include config file
include_once 'config.inc.php';
// include global common file
include_once str_replace('admin/', '', ROOT).'includes/common.global.inc.php';


/**
 * Check that a User is logged in, redirect to login page if not
 * @return bool
 */
function check_login() {
	if(!isset($_SESSION['User'])) {
		$_SESSION['flash'] = array('type'=>'bad','msg'=>'You need to be logged to access that section');
		header('Location: '.ROOT_URL.'login.php');
		exit;
	}

	// check login time
	if(isset($_SESSION['Time'])) {
		// allow sessions to run this long
		$period = 60*60;
		if( mktime() - $_SESSION['Time'] >= $period ) {
			unset($_SESSION['User']);
			$_SESSION['flash'] = array('type'=>'bad','msg'=>'Your session has expired, please log in again');
			header('Location: '.ROOT_URL.'login.php');
			exit;
		}
	}

return TRUE;
}


/**
 * Logout a User
 */
function logout() {
	unset($_SESSION['User']);
	redirect(ROOT_URL.'login.php');
}


/**
 * Connects to database
 * @return db class
 */
function db_connect() {
	// create database instance
	$db = new DB(array(
		'hostname'=>HOSTNAME,
		'username'=>DB_USERNAME,
		'password'=>DB_PASSWORD,
		'db_name'=>DB_NAME
	));

	// stop on db fail
	if($db===FALSE) {
		pr($db->errors);
		exit;
	}

return $db;
}


/**
 * Checks the user is in db
 * @param string $username
 * @param string $password
 * @return bool
 */
function check_user($username, $password) {
	// connect to db
	$db = db_connect();
	// get user from db
	$user = $db->get_row("SELECT users.* FROM users WHERE users.username='".$db->escape($username)."'");
	
	// username not found
	if(empty($user)) {
		return FALSE;
	}

	// password not correct
	if(md5($password.SALT) != $user['password']) {
		return FALSE;
	}

	// save user in session
	$_SESSION['User'] = $user;
	// save login time so that we can limit the time
	$_SESSION['Time'] = mktime();

return TRUE;
}