<?php
// include common file
include_once './includes/config.inc.php';
// check a user is logged in
check_login();

// approve a store
if(isset($_GET['action']) && $_GET['action']=='approve') {
	// check id is passed and is valid
	if(!isset($_GET['id']) || !is_numeric($_GET['id'])) {
		$_SESSION['flash'] = array('type'=>'bad','msg'=>'Invalid Id');
		redirect(ROOT_URL.'stores.php');
	}

	// set the approved flag to 1
	$db = db_connect();
	if($db->update('stores',array('approved'=>1),$_GET['id'])) {
		$_SESSION['flash'] = array('type'=>'good','msg'=>'Store succesfully approved');
	} else {
		$_SESSION['flash'] = array('type'=>'bad','msg'=>'There was a problem approving the Store, please try again');
	}
redirect(ROOT_URL.'stores.php');
}

// delete a store
if(isset($_GET['action']) && $_GET['action']=='delete') {
	// check id is passed and is valid
	if(!isset($_GET['id']) || !is_numeric($_GET['id'])) {
		$_SESSION['flash'] = array('type'=>'bad','msg'=>'Invalid Id');
		redirect(ROOT_URL.'stores.php');
	}

	// set the status to 0
	$db = db_connect();
	if($db->update('stores',array('status'=>0),$_GET['id'])) {
		$_SESSION['flash'] = array('type'=>'good','msg'=>'Store succesfully deleted');
	} else {
		$_SESSION['flash'] = array('type'=>'bad','msg'=>'There was a problem deleting the Store, please try again');
	}
redirect(ROOT_URL.'stores.php');
}

// get active stores
$db = db_connect();
$stores = $db->get_rows("SELECT stores.* FROM stores WHERE stores.status=1 ORDER BY stores.name");
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
	<title>Stores</title>
	<link rel="stylesheet" type="text/css" href="./css/style.css" media="all" />
	<script type="text/javascript" src="./js/jquery-1.3.2.min.js"></script>
	<script type="text/javascript" src="./js/jquery-common.js"></script>
</head>
<body id="stores">
	<div id="wrapper">
		<div id="header">
			<h1>Store Locator</h1>
			<ul id="nav">
				<li class="n_dashboard"><a href="./">Dashboard</a></li>
				<li class="n_stores"><a href="./stores.php">Stores</a></li>
				<li class="n_logout"><a href="./logout.php">Logout</a></li>
			</ul>
		</div>
		<div id="main">
			<a href="./stores_add.php" class="fright iconAdd index_add">Add Store</a>
			<h2>Stores</h2>
			<?php echo flash(); ?>

			<table>
				<thead>
				<tr>
					<th>Name</th>
					<th>Address</th>
					<th>Telephone</th>
					<th>Email</th>
					<th>Website</th>
					<th class="acenter">Approved</th>
					<th class="actions">Actions</th>
				</tr>
				</thead>
				<tbody>
				<?php if(!empty($stores)): ?>
					<?php foreach($stores as $k=>$v): ?>
					<tr class='<?php echo ($k%2==0) ? 'odd':'even'; ?>'>
						<td><?php echo $v['name']; ?></td>
						<td><?php echo $v['address']; ?></td>
						<td><?php echo $v['telephone']; ?></td>
						<td><?php echo $v['email']; ?></td>
						<td><?php echo $v['website']; ?></td>
						<td class="acenter"><?php echo ($v['approved']) ? 'Yes' : 'No' ; ?></td>
						<td class="actions">
							<a href='./stores_edit.php?id=<?php echo $v['id']; ?>'><img src="./imgs/icons/page_edit.png" alt="Store Edit Icon"/></a>
							<a href='?action=delete&amp;id=<?php echo $v['id']; ?>' class="confirm_delete"><img src="./imgs/icons/bin.png" alt="Store Delete Icon"/></a>
							<?php if(!$v['approved']) : ?>
							<a href='?action=approve&amp;id=<?php echo $v['id']; ?>'>Approve</a>
							<?php endif; ?>
						</td>
					</tr>
					<?php endforeach; ?>
				<?php else: ?>
					<tr>
						<td colspan="7">Currenty no <strong>Stores</strong> to display</td>
					</tr>
				<?php endif; ?>
				</tbody>
			</table>

		</div>
	</div>
</body>
</html>