var win = Ti.UI.currentWindow;

win.hideNavBar();

// Background image view
var bgImage = Ti.UI.createImageView({
	height	: 180,
	top		: -11,
	image	: 'images/headerTexture.jpg',
	zIndex	: 0
});
win.add(bgImage);

// Logo image view
var logoImage = Ti.UI.createImageView({
	width	: 172,
	height	: 116,
	top		: 30,
	image	: 'images/logo.png'
});
win.add(logoImage);

// List of data
var data = [
	{ 
		title		: 'Email Us', 
		name		: 'email',
		leftImage	: 'images/icons/30png/Closed-Mail.png',
		height		: 50,		
		color		: '#fff',		
		selectedBackgroundColor: '#444',
		backgroundColor	: 'transparent',		
		hasChild	: true 
	},
	{ 
		title		: 'Call Us',
		name		: 'phone',
		leftImage	: 'images/icons/30png/Microphone.png',
		height		: 50,
		color		: '#fff',
		selectedBackgroundColor: '#444',		
		hasChild	: true
	},
	{ 
		title		: 'Client Login', 
		name		: 'login',
		leftImage	: 'images/icons/30png/Lock.png',
		height		: 50,	
		color		: '#fff',
		selectedBackgroundColor: '#444',					
		hasChild	: true 
	},	
	{ 
		title		: 'Directions', 
		name		: 'directions',
		leftImage	: 'images/icons/30png/Marker.png',
		height		: 50,
		color		: '#fff',				
		selectedBackgroundColor: '#444',		
		hasChild	: true 
	},
	{ 
		title		: 'Website', 
		name		: 'website',
		leftImage	: 'images/icons/30png/Picture.png',
		height		: 50,	
		color		: '#fff',	
		selectedBackgroundColor: '#444',				
		hasChild	: true 
	}	

];

// ----- Create the actual tableView for the page ----- //
var tableview = Titanium.UI.createTableView({
	data			: data,
	layout			: 'vertical',
	height			: '67%',
	bottom			: 0,
	backgroundImage	: 'transparent',
	background		: 'transparent',
    backgroundColor	: 'transparent',
	separatorColor	: '#050505',
	style			: Titanium.UI.iPhone.TableViewStyle.GROUPED
});
win.add(tableview);

// ----- Create an event listener for the tableView ----- //
tableview.addEventListener('click', function(e) {
	// Determine what to do by the 'name' property stored in the rowData
	switch(e.rowData.name)
	{
		// Email / contact submission
		case 'email':
			var emailDialog = Titanium.UI.createEmailDialog();	// Create the email dialog object
			emailDialog.subject = "iPhone App Contact Submission: ";  // Set the subject
			emailDialog.toRecipients = ['info@somedomain.com'];  // Set the recipients email addy (your company addy)
			emailDialog.messageBody = '';  // If you need to, set body message
			emailDialog.open();  // Open the email dialog
			break;
		// Phone call (won't work in simulator)
		case 'phone':
			Ti.Platform.openURL('tel: 1231231234');  // Call your company number (only works on live phone)
			break;
		// Directions / map
		case 'directions':
			// Paste in the directions / link to your business (Use Google maps).
			// In the simulator it will open Safari.  On the phone it will open the Google maps app
			Ti.Platform.openURL('http://maps.google.com/maps?f=q&source=s_q&hl=en&geocode=&q=MIT&sll=37.0625,-95.677068&sspn=61.669968,73.037109&ie=UTF8&hq=Massachusetts+Institute+of+Technology&hnear=Massachusetts+Institute+of+Technology,+Boston,+Suffolk,+Massachusetts+02139&z=14&iwloc=A');
			break;
		// Login opens website
		case 'login':
			// Paste in your customer login area and it will open in Safari
			Ti.Platform.openURL('http://themeforest.net');
			break;	
		// Paste in your website address here
		case 'website':
			// Paste in your customer login area and it will open in Safari
			Ti.Platform.openURL('http://nettuts.com');
			break;								
	}
});
