var win = Ti.UI.currentWindow;

win.hideNavBar();

// Background image view
var bgImage = Ti.UI.createImageView({
	height	: 180,
	top		: -11,
	image	: 'images/headerTexture.jpg',
	zIndex	: 0
});
win.add(bgImage);

// Logo image view
var logoImage = Ti.UI.createImageView({
	width	: 172,
	height	: 116,
	top		: 30,
	image	: 'images/logo.png'
});
win.add(logoImage);

var data = [
	{ 
		title		: 'Hosting',
		page		: 'hosting',
		leftImage	: 'images/ico_hosting.png',
		height		: 50,
		color		: '#fff',
		selectedBackgroundColor: '#444',		
		hasChild	: true
	},
	{ 
		title		: 'Web Design & Dev', 
		page		: 'webdesign',
		leftImage	: 'images/ico_design.png',
		height		: 50,		
		color		: '#fff',		
		selectedBackgroundColor: '#444',		
		hasChild	: true 
	},
	{ 
		title		: 'Template Design', 
		page		: 'templatedesign',
		leftImage	: 'images/ico_template.png',
		height		: 50,
		color		: '#fff',				
		selectedBackgroundColor: '#444',		
		hasChild	: true 
	},
	{ 
		title		: 'CMS', 
		page		: 'cms',
		leftImage	: 'images/ico_cms.png',
		height		: 50,	
		color		: '#fff',
		selectedBackgroundColor: '#444',					
		hasChild	: true 
	},
	{ 
		title		: 'Tech Training', 
		page		: 'techtraining',
		leftImage	: 'images/ico_training.png',
		height		: 50,	
		color		: '#fff',	
		selectedBackgroundColor: '#444',				
		hasChild	: true 
	}	

];

// ----- Create the actual tableView for the page ----- //
var tableview = Titanium.UI.createTableView({
	data			: data,			// The data to populate the tableView
	layout			: 'vertical',	// The type of layout to use
	height			: '70%',
	bottom			: 0,
	backgroundImage	: 'transparent',
	background		: 'transparent',
    backgroundColor	: 'transparent',
	separatorColor	: '#050505',
	style			: Titanium.UI.iPhone.TableViewStyle.GROUPED
});
win.add(tableview);

// ----- Create an event listener for the tableView ----- //
tableview.addEventListener('click', function(e) {
	/**
	 * Here we're creating a new window to open when a row is clicked
	 * this will load another javascript page to be used for the window
	 */	
	var reviews_window = Titanium.UI.createWindow({  
		/**
		 * The title to set for the new window.  In this case it loads the text from the 2 item / label
		 * in the row
		 */
	    title			: e.rowData.title,
		url				: e.rowData.page + '.js',	// The file to use for the new window
		barColor		: '#050505',
		backgroundColor	: '#050505'
	});
	
	// Pass the row data to the new window for use
	reviews_window.data = e.rowData;
	
	// Open the window in the current tab
	Titanium.UI.currentTab.open(reviews_window, { animated:true });
});
