<?
class download{

	static protected $dir_list = array();
	static protected $_bandwidth = 0;
	static protected $options = array(
		'display_name' => 'Filename',
		'prefix_name' => 'Download Site',
	);

	function __construct() {
		$args = func_get_args();
		$count = func_num_args();
		if(is_array($args[0])){
			foreach($args[0] as $i => $v){
				self::$options[$i] = $v;
			}
		}else{
			$value = array('file_path', 'prefix_name', 'display_name');
			for($i = 0; $i < $count; $i++){
				self::$options[$value[$i]] = $args[$i];
			}
		}
		
		if(empty(self::$options['file_path'])){
			exit('Error Setting: "file_path" varible is NULL.');
		}
		
		self::_start();
		
		return TRUE;
	}
	
	private function _listDir($dir_path){
		if ($dir = opendir($dir_path)) {
			while (($_file = readdir($dir)) !== false) {
				if($_file != '.' && $_file != '..'){
					if(is_dir($dir_path.'/'.$_file)){
						self::_listDir($dir_path.'/'.$_file);
					}else{
						self::$dir_list[] = $dir_path.'/'.$_file;
					}
				}
			}
			closedir($dir);
		}
	}
	
	private function _isIE(){
		return (isset($_SERVER['HTTP_USER_AGENT']) && (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false)) ? TRUE : FALSE;
	}
	
	private function _getIP(){
		if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
			$ip = $_SERVER['HTTP_CLIENT_IP'];
		} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
			$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		} else {
			$ip = $_SERVER['REMOTE_ADDR'];
		}
		return $ip;
	}
	
	private function _getMime($filename) {
		
		// included txt,html,php,css,js,json,xml,swf,flv,png,jpe,jpeg,jpg,gif,bmp,ico,tiff,tif,svg,svgz,zip,rar,exe
		//          msi,cab,mp3,mpa,mpe,mpeg,mpg,qt,mov,pdf,psd,ai,eps,ps,doc,rtf,xls,ppt,odt,od3
        $mime_types = array('txt' => 'text/plain','htm' => 'text/html','html' => 'text/html','php' => 'text/html','css' => 'text/css','js' => 'application/javascript','json' => 'application/json','xml' => 'application/xml','swf' => 'application/x-shockwave-flash','flv' => 'video/x-flv','png' => 'image/png','jpe' => 'image/jpeg','jpeg' => 'image/jpeg','jpg' => 'image/jpeg','gif' => 'image/gif','bmp' => 'image/bmp','ico' => 'image/vnd.microsoft.icon','tiff' => 'image/tiff','tif' => 'image/tiff','svg' => 'image/svg+xml','svgz' => 'image/svg+xml','zip' => 'application/zip','rar' => 'application/x-rar-compressed','exe' => 'application/x-msdownload','msi' => 'application/x-msdownload','cab' => 'application/vnd.ms-cab-compressed','mp3' => 'audio/mpeg','mpa' => 'video/mpeg','mpe' => 'video/mpeg','mpeg' => 'video/mpeg','mpg' => 'video/mpeg','qt' => 'video/quicktime','mov' => 'video/quicktime','pdf' => 'application/pdf','psd' => 'image/vnd.adobe.photoshop','ai' => 'application/postscript','eps' => 'application/postscript','ps' => 'application/postscript','doc' => 'application/msword','rtf' => 'application/rtf','xls' => 'application/vnd.ms-excel','ppt' => 'application/vnd.ms-powerpoint','odt' => 'application/vnd.oasis.opendocument.text','ods' => 'application/vnd.oasis.opendocument.spreadsheet');

        $ext = strtolower(array_pop(explode('.',$filename)));
        if (array_key_exists($ext, $mime_types)) {
            return $mime_types[$ext];
        } elseif (function_exists('finfo_open')) {
            $finfo = finfo_open(FILEINFO_MIME);
            $mimetype = finfo_file($finfo, $filename);
            finfo_close($finfo);
            return $mimetype;
        } else {
            return 'application/octet-stream';
        }
    }
	
	private function _getInfo($file_path){
		@clearstatcache();
		$file_path_info = pathinfo($file_path);
		return array('file_size' => @filesize($file_path), 'file_name' => $file_path_info['basename'], 'file_extension' => strtolower($file_path_info['extension']), 'mime' => self::_getMime($file_path_info['basename']));
	}
		
	private function _start() {
		if (@file_exists(self::$options['file_path'])) {
			if(is_dir(self::$options['file_path'])){
				if(version_compare(PHP_VERSION, '5.2.0', '<')){
					echo 'Not supported dir-to-zip download.';
					exit;
				}
				$zip = new ZipArchive;
				$_dir_name = array_pop(explode('/', str_replace('\\', '/', self::$options['file_path'])));
				if (($zip->open('./tmp/'.$_dir_name.'.zip', ZipArchive::CREATE)) === TRUE) {
					self::_listDir(self::$options['file_path']);
					for($i=0;$i<count(self::$dir_list);$i++){
						$zip->addFile(self::$dir_list[$i], str_replace(self::$options['file_path'], '', self::$dir_list[$i]));
					}
					$zip->close();
					self::$options['file_path'] = './tmp/'.$_dir_name.'.zip';
				}else{
					echo 'error - can\'t create a zip file.';
					exit;
				}
			}
			
			$file_info = self::_getInfo(self::$options['file_path']);
			$exten = pathinfo($file_info['file_name'], PATHINFO_EXTENSION);
			
			ob_end_clean();
			set_time_limit(0);
			ignore_user_abort(true);
					
			# Cache Control
			header('Pragma: cache');
			header('Expires: 0');
			header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
			header('Cache-Control: private'); 
			
			$filename = (!empty(self::$options['prefix_name']) ? '['.self::$options['prefix_name'].'] ' : '').self::$options['display_name'].".".$exten;
			
			header('Content-Transfer-Encoding: binary');
			header('Content-Type: '.$file_info['mime']);

			if(self::$options['allowed_stream'] != 'flv'){
				$content_disposition = (self::$options['allowed_stream'] == TRUE && in_array($file_info['file_extension'], array('mp3','m3u','m4a','mid','ogg','ra','ram','wm','wav','wma','aac','3gp','avi','mov','mp4','mpeg','mpg','swf','wmv','divx','asf'))) ? 'inline' : 'attachment';
				header('Content-Disposition: '.$content_disposition.'; filename="'.((self::_isIE()) ? rawurlencode($filename) : $filename).'"');
			}
			header('Content-length: '.$file_info['file_size']);
			
			$handle = fopen(self::$options['file_path'], 'rb');
			fseek($handle, $seek_start);
			while(!feof($handle) && (connection_status()==0)) {
				$buffed_size = 0;
				if(!empty(self::$options['download_speed_limit'])) list($speed, $second) = explode('/', self::$options['download_speed_limit']);
				echo fread($handle, ($buffed_size += ((isset($speed) && $speed > 0) ? round(1024*$speed) : 1024)));
				flush();
				ob_flush();
				if(isset($second) && self::$options['allowed_stream'] != 'flv') sleep($second);
			}
			fclose($handle);
			
			if(isset($_dir_name)){
				@unlink(self::$options['file_path']);
			}
			if(!empty(self::$options['strict_protect']) && isset($_SESSION['eDownload_'.md5(self::$options['strict_protect'].self::$options['file_path'])])){
				unset($_SESSION['eDownload_'.md5(self::$options['strict_protect'].self::$options['file_path'])]);
			}
		}else{
			header('HTTP/1.1 404 Not Found');
			echo 'File Not Found';
		}
		exit;
	}
}
?>