# --------------------------------------------------------
# Host:                         jakelprice.com
# Server version:               5.0.91-community-log
# Server OS:                    unknown-linux-gnu
# HeidiSQL version:             6.0.0.3603
# Date/time:                    2011-02-23 12:00:44
# --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

# Dumping structure for table jakelpri_buysell.cats
CREATE TABLE IF NOT EXISTS `cats` (
  `catID` int(10) NOT NULL auto_increment,
  `catName` varchar(255) NOT NULL,
  `catText` varchar(255) NOT NULL,
  PRIMARY KEY  (`catID`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 COMMENT='Category Table';

# Dumping data for table jakelpri_buysell.cats: 1 rows
/*!40000 ALTER TABLE `cats` DISABLE KEYS */;
INSERT INTO `cats` (`catID`, `catName`, `catText`) VALUES
	(1, 'Category One', 'Some Category Text');
/*!40000 ALTER TABLE `cats` ENABLE KEYS */;


# Dumping structure for table jakelpri_buysell.comments
CREATE TABLE IF NOT EXISTS `comments` (
  `comment_id` int(10) NOT NULL auto_increment,
  `comment_item` int(10) NOT NULL default '0',
  `comment_author` varchar(255) NOT NULL default '0',
  `comment_date` varchar(255) NOT NULL default '0',
  `comment_pur` int(10) NOT NULL default '0',
  `comment_aut` int(10) NOT NULL default '0',
  `comment` text NOT NULL,
  PRIMARY KEY  (`comment_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

# Dumping data for table jakelpri_buysell.comments: 0 rows
/*!40000 ALTER TABLE `comments` DISABLE KEYS */;
/*!40000 ALTER TABLE `comments` ENABLE KEYS */;


# Dumping structure for table jakelpri_buysell.history
CREATE TABLE IF NOT EXISTS `history` (
  `histID` int(10) NOT NULL auto_increment,
  `userID` varchar(255) NOT NULL,
  `date` varchar(255) NOT NULL,
  `type` varchar(50) NOT NULL,
  `Log` varchar(255) NOT NULL,
  PRIMARY KEY  (`histID`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 COMMENT='Table recording everyones history - logging';

# Dumping data for table jakelpri_buysell.history: 0 rows
/*!40000 ALTER TABLE `history` DISABLE KEYS */;
/*!40000 ALTER TABLE `history` ENABLE KEYS */;


# Dumping structure for table jakelpri_buysell.items
CREATE TABLE IF NOT EXISTS `items` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `author` int(10) NOT NULL,
  `cat` int(255) NOT NULL COMMENT 'Link to ''cats'' table',
  `descr` text NOT NULL,
  `date` varchar(50) NOT NULL,
  `price` double NOT NULL,
  `sales` int(10) NOT NULL,
  `image_main` varchar(255) NOT NULL,
  `image_thumb` varchar(255) NOT NULL,
  `download_link` varchar(255) NOT NULL,
  `published` int(10) NOT NULL COMMENT '0 = False, 1 = True',
  `live_link` varchar(255) NOT NULL COMMENT 'Link to view link',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Item and Product Table';

# Dumping data for table jakelpri_buysell.items: 0 rows
/*!40000 ALTER TABLE `items` DISABLE KEYS */;
/*!40000 ALTER TABLE `items` ENABLE KEYS */;


# Dumping structure for table jakelpri_buysell.payments
CREATE TABLE IF NOT EXISTS `payments` (
  `paymentID` int(10) NOT NULL auto_increment,
  `payType` varchar(50) NOT NULL,
  `txn` varchar(255) NOT NULL,
  `buyer_id` varchar(255) NOT NULL,
  `item_id` int(10) NOT NULL,
  `amount` float NOT NULL,
  `fee` float NOT NULL,
  PRIMARY KEY  (`paymentID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Table holding all Payments';

# Dumping data for table jakelpri_buysell.payments: 0 rows
/*!40000 ALTER TABLE `payments` DISABLE KEYS */;
/*!40000 ALTER TABLE `payments` ENABLE KEYS */;


# Dumping structure for table jakelpri_buysell.payout
CREATE TABLE IF NOT EXISTS `payout` (
  `id` int(10) NOT NULL auto_increment,
  `user_id` int(10) NOT NULL default '0',
  `amount` varchar(50) NOT NULL default '0',
  `dt` int(15) NOT NULL default '0',
  `com` int(10) NOT NULL default '0',
  `dt_com` int(10) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Payout table';

# Dumping data for table jakelpri_buysell.payout: 0 rows
/*!40000 ALTER TABLE `payout` DISABLE KEYS */;
/*!40000 ALTER TABLE `payout` ENABLE KEYS */;


# Dumping structure for table jakelpri_buysell.settings
CREATE TABLE IF NOT EXISTS `settings` (
  `name` varchar(255) default NULL,
  `value` varchar(255) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Settings Table';

# Dumping data for table jakelpri_buysell.settings: 7 rows
/*!40000 ALTER TABLE `settings` DISABLE KEYS */;
INSERT INTO `settings` (`name`, `value`) VALUES
	('sitename', 'New BuyandSell'),
	('debug', 'true'),
	('base_url', 'http://jakelprice.com/buyandsell/'),
	('paypal_email', 'jake@jakelprice.com'),
	('admin_email', 'jake@jakelprice.com'),
	('cut', '75'),
	('notify_new_sub', '1');
/*!40000 ALTER TABLE `settings` ENABLE KEYS */;


# Dumping structure for table jakelpri_buysell.users
CREATE TABLE IF NOT EXISTS `users` (
  `user_id` int(10) NOT NULL auto_increment,
  `username` varchar(244) NOT NULL default '0',
  `password` varchar(244) NOT NULL default '0',
  `email` varchar(244) NOT NULL default '0',
  `balance` double NOT NULL default '0',
  `admin` int(11) NOT NULL default '0',
  `descr` text NOT NULL,
  `join_date` int(10) NOT NULL,
  `pending` varchar(50) NOT NULL default '0.00',
  `paid` varchar(50) NOT NULL default '0.00',
  `facebook` varchar(255) NOT NULL,
  `twitter` varchar(255) NOT NULL,
  `youtube` varchar(255) NOT NULL,
  `linkedin` varchar(255) NOT NULL,
  PRIMARY KEY  (`user_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

# Dumping data for table jakelpri_buysell.users: 1 rows
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
INSERT INTO `users` (`user_id`, `username`, `password`, `email`, `balance`, `admin`, `descr`, `join_date`, `pending`, `paid`, `facebook`, `twitter`, `youtube`, `linkedin`) VALUES
	(1, 'admin', '21232f297a57a5a743894a0e4a801fc3', 'jake@jakelprice.com', 0, 1, 'This is a &lt;span style=&quot;font-weight: bold;&quot;&gt;test&lt;/span&gt;', 1275820648, '0', '20', 'jakeprice', 'jakelprice', '', '');
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
