<?php
 /*
	Plugin Name: Extended Tags Widget
	Plugin URI: http://zourbuth.com/plugins/extended-tags-widget
	Description: An advanced widget that gives you total control over the output of your tags. The Tags widget replaces the default WordPress Tag Cloud widget. This version gives total control over the output to the user by allowing the input of all the arguments typically seen in the wp_tag_cloud() function
	Version: 1.0
	Author: Zourbuth
	Author URI: http://zourbuth.com
	License: Under GPL2
*/
 
/*  
    Copyright 2011 zourbuth (email : zourbuth@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* Launch the plugin. */
add_action( 'plugins_loaded', 'extended_tags_widget_plugins_loaded' );

/* Initializes the plugin and it's features. */
function extended_tags_widget_plugins_loaded() {

	/* Set constant path to the members plugin directory. */
	define( 'EXTENDED_TAGS_WIDGET_DIR', plugin_dir_path( __FILE__ ) );

	/* Set constant path to the members plugin directory. */
	define( 'EXTENDED_TAGS_WIDGET_URL', plugin_dir_url( __FILE__ ) );

	/* Loads and registers the new widgets. */
	add_action( 'widgets_init', 'extended_tags_widget_load_widgets' );
}

/* Register the extra widgets. Each widget is meant to replace or extend the current default  */
function extended_tags_widget_load_widgets() {

	/* Load widget file. */
	require_once( EXTENDED_TAGS_WIDGET_DIR . 'extended-tags-widget.php' );

	/* Register widget. */
	register_widget( 'Extended_Tags_Widget' );
}

?>