<?php
/*
Plugin Name: Facebook WPress
Plugin URI: http://yougapi.com/products/wordpress/facebook_wpress/
Description: Integrate Facebook connect and Facebook social functionnalities to your WordPress.
Version: 1.0
Author: Yougapi Technology LLC
Author URI: http://yougapi.com
*/

define(FACEBOOK_WPRESS_ID, 'facebook_wpress_id');
define(FACEBOOK_WPRESS_ADMIN_ID, 'facebook_wpress_admin_id');

require_once dirname( __FILE__ ).'/include/webzone.php';
if(is_admin()) {
	require_once dirname( __FILE__ ).'/admin.php';
	require_once dirname( __FILE__ ).'/db.php';
	//create table on plugin activation (if table doesn't exist)
	register_activation_hook(__FILE__, array('Facebook_wpress', 'setDefaultValues'));
	register_activation_hook(__FILE__, array('Facebook_wpress_db', 'createTable'));
}

//include javascripts
add_action( 'wp_print_scripts', array('Facebook_wpress', 'add_js_scripts') );

//instantialize the class
$fb1 = new Facebook_wpress();
//load the Javascript SDK
add_action('wp_footer',array('Facebook_wpress', 'loadJsSDK'),20);
// register the widget
add_action("plugins_loaded",array('Facebook_wpress', 'widget_registration'));


class Facebook_wpress {
	
	function add_js_scripts() {
		wp_enqueue_script( 'facebook_wpress_ajax', plugin_dir_url( __FILE__ ) . 'ajax.js', array( 'jquery' ) );
		wp_localize_script( 'facebook_wpress_ajax', 'MyAjax', array( 'ajaxurl' => admin_url('admin-ajax.php') ) );
	}

	function Facebook_wpress() {
		$this->setFacebookAppData();
	}
	
	function setFacebookAppData() {
		$options = get_option(FACEBOOK_WPRESS_ADMIN_ID);
		$fb_app_id = $options['fb_app_id'];
		$fb_app_secret = $options['fb_app_secret'];
		//Declare the static variables
		define(FACEBOOK_APP_ID, $fb_app_id);
		define(FACEBOOK_SECRET, $fb_app_secret);
	}
	
	function loadJsSDK() {
		$f1 = new Facebook_class();
		$f1->loadJsSDK();
	}
	
	// #### START ### Widget ##############
	// ####################################
	
	function widget_registration() {
		wp_register_sidebar_widget(FACEBOOK_WPRESS_ID, 'Facebook WPress', array('Facebook_wpress', 'widget_init'));
		wp_register_widget_control(FACEBOOK_WPRESS_ID, 'Facebook WPress', array('Facebook_wpress', 'widget_control'));
	}
	
	function widget_init() {
		echo $before_widget;
		$tmp = new Facebook_wpress();
		$tmp->widget_display();
		echo $after_widget;
	}
	
	function widget_display() {
		if(FACEBOOK_APP_ID!=''&&FACEBOOK_SECRET!='') {
			$f1 = new Facebook_class();
			$fb_cookie = $f1->getCookie();
			if($fb_cookie!='') {
				$user_data = $f1->getUserData();
				$fb_profile_picture = $f1->getProfilePicture();
				$fb_link = $user_data->link;
				$fb_userid = $f1->getUserid();
				$fb_full_name = $user_data->name;
				echo '<div class="widget">';
				echo '<div><a href="'.$fb_link.'" title="'.$fb_full_name.'" target="_blank"><img align="center" src="'.$fb_profile_picture.'" width=46 align="left" style="padding-right:5px;"></a> ';
				echo 'Connected as '.$fb_full_name.' (<small><a href="javascript:" onclick="logoutFacebookUser()">Log out</a></small>)</div>';
				$this->display_friends();
				echo '</div>';
			}
			else {
				echo '<div class="widget">';
				echo '<a href="javascript:" onclick="fbActionConnect();" title="Connect with Facebook">
				<img src="'.get_bloginfo('wpurl').'/wp-content/plugins/facebook_wpress/include/graph/facebook-connect-logo-160.jpg" width=140>
				</a>';
				$this->displayConnectedUsers();
				echo '</div>';
			}
		}
		else {
			//echo 'The Facebook application config data are missing.';
		}
	}
	
	function displayConnectedUsers() {
		$options = get_option(FACEBOOK_WPRESS_ID);
		$show_connected = $options['show_connected'];
		$nb_connected = $options['nb_connected'];
		
		if($show_connected && $nb_connected>0) {
			require_once dirname( __FILE__ ).'/db.php';
			$f1 = new Facebook_wpress_db();
			$users = $f1->getConnectedUsers();
			if(count($users)>0) {
				echo '<br><br><p>';
				//echo '<b>Last connected</b><br>';
				$f1 = new Facebook_class();
				$users = $f1->displayUsersIcons(array('users'=>$users, 'nb_display'=>$nb_connected, 'privacy'=>1));
				echo '<small>Last connected</small> <p>'.$users.'</p>';
				echo '</p>';
			}
		}
	}
	
	function setDefaultValues() {
		$options['show_friends'] = '1';
		$options['nb_friends'] = '10';
		$options['show_connected'] = '0';
		$options['nb_connected'] = '10';
		update_option(FACEBOOK_WPRESS_ID, $options);
	}
	
	function display_friends() {
		$options = get_option(FACEBOOK_WPRESS_ID);
		$show_friends = $options['show_friends'];
		$nb_friends = $options['nb_friends'];
		//display friends
		if($show_friends && $nb_friends>0) {
			$f1 = new Facebook_class();
			$fb_friends = $f1->getFacebookFriends();
			if(count($fb_friends)>0) {
				echo '<br>';
				echo '<small>Friends</small><p>';
				$fb_friends_display = $f1->displayUsersIcons(array('users'=>$fb_friends, 'nb_display'=>$nb_friends));
				echo $fb_friends_display.'';
				echo '</p>';
			}
		}
	}
	
	function widget_control() {
		$options = get_option(FACEBOOK_WPRESS_ID);
		if (!is_array($options)) {
			$options = array();
		}
		
		$widget_data = $_POST[FACEBOOK_WPRESS_ID];
		if ($widget_data['submit']) {
			$options['show_friends'] = $widget_data['show_friends'];
			$options['nb_friends'] = $widget_data['nb_friends'];
			$options['show_connected'] = $widget_data['show_connected'];
			$options['nb_connected'] = $widget_data['nb_connected'];
			update_option(FACEBOOK_WPRESS_ID, $options);
		}
		
		$show_friends = $options['show_friends'];
		$nb_friends = $options['nb_friends'];
		$show_connected = $options['show_connected'];
		$nb_connected = $options['nb_connected'];
		
		echo '<p>';
			echo '<label for="'.FACEBOOK_WPRESS_ID.'-show_friends">';
			echo 'Show friends:';
			echo '</label>';
			echo '<select class="widefat" name="'.FACEBOOK_WPRESS_ID.'[show_friends]" 
			id="'.FACEBOOK_WPRESS_ID.'-show_friends">';
			if($show_friends=='1') echo '<option value="1" selected>Yes</option>';
			else echo '<option value="1">Yes</option>';
			if($show_friends=='0') echo '<option value="0" selected>No</option>';
			else echo '<option value="0">No</option>';
			echo '</select>';
		echo '</p>';
		
		echo '<p>';
			echo '<label for="<?php echo FACEBOOK_WPRESS_ID;?>-nb_friends">';
			echo 'Number of friends to show:';
			echo '</label>';
			echo '<input class="widefat" type="text" name="'.FACEBOOK_WPRESS_ID.'[nb_friends]" id="'.FACEBOOK_WPRESS_ID.'-nb_friends" 
			value="'.$nb_friends.'">';
		echo '</p>';
		
		echo '<p>';
			echo '<label for="'.FACEBOOK_WPRESS_ID.'-show_connected">';
			echo 'Show connected users:';
			echo '</label>';
			echo '<select class="widefat" name="'.FACEBOOK_WPRESS_ID.'[show_connected]" 
			id="'.FACEBOOK_WPRESS_ID.'-show_connected">';
			if($show_connected=='1') echo '<option value="1" selected>Yes</option>';
			else echo '<option value="1">Yes</option>';
			if($show_connected=='0') echo '<option value="0" selected>No</option>';
			else echo '<option value="0">No</option>';
			echo '</select>';
		echo '</p>';
		
		echo '<p>';
			echo '<label for="<?php echo FACEBOOK_WPRESS_ID;?>-nb_connected">';
			echo 'Number of connected users to show:';
			echo '</label>';
			echo '<input class="widefat" type="text" name="'.FACEBOOK_WPRESS_ID.'[nb_connected]" id="'.FACEBOOK_WPRESS_ID.'-nb_connected" 
			value="'.$nb_connected.'">';
		echo '</p>';
		
		echo '<input type="hidden" name="'.FACEBOOK_WPRESS_ID.'[submit]" value="1">';
	}
	
}

?>