<?php if ( ! defined('APP_ABSPATH')) exit('No direct script access allowed');
class Controller {
	public $load;
	public $model;
	public $input;
	public $helpers;
	public $router;

	/*
	*	The Constructor method
	*	Creates instances of the classes that will be needed here
	*	Using the Router class it then calls the function that corresponds to the url
	*/
	function __construct(){
		$this->view = new View();
		$this->model = new Model();
		$this->input = new Input();
		$this->helpers = new Helpers();
		$this->validation = new Validation();
	  
		$this->router = new Router();
		$the_route = $this->router->get();
		eval($the_route);
	}
	
	/*
	*	This method processes a form when it is submitted.
	*	Argument: $id - of the form to be processed
	*/
	function submit_form($id){
		$data = array();
		$output = array();
		$data['error'] = 0;
		$data['success'] = 0;
		
		$data['error_msg'] = '';
		$data['success_msg'] = '';
		
		$form = $this->model->get_form($id);
		
		$values = array();
		
		$required = explode(',', str_replace(' ', '', $form['required_fields']));
		$optional = explode(',', str_replace(' ', '', $form['optional_fields']));
		
		if($required){
			foreach($required as $r){
				$field = $this->model->get_field(array('form_id' => $id, 'name' => $r));
				if($field['display_name']){
					$display_name = $field['display_name'];
				} else {
					$display_name = $r;
				}
				if($r != ''){
					if($_POST[$r] == ''){
						$data['error_msg'] .= '<li>The field "' . $display_name .'" is required.</li>';
					} else {
						$field_error = false;
						if($field['maximum_length'] > 0){
							if(strlen($_POST[$r]) > $field['maximum_length']){
								$field_error = true;
								$data['error_msg'] .= '<li>The field "' . $display_name .'" should be less than ' . $field['maximum_length'] . ' characters long.</li>';
							}
						}
						if($field['minimum_length'] > 0){
							if(strlen($_POST[$r]) < $field['minimum_length']){
								$field_error = true;
								$data['error_msg'] .= '<li>The field "' . $display_name .'" should be more than ' . $field['minimum_length'] . ' characters long.</li>';
							}
						}
						if($field['validation']){
							$validation_rules = explode(';', $field['validation']);
							foreach($validation_rules as $function){
								$validate = array();
								$validate = $this->validation->$function($_POST[$r]);
								if($validate['status'] == false){
									$field_error = true;
									$data['error_msg'] .= '<li>For the field "' . $display_name .'": '. $validate['error'] . '</li>';
								}
							}
						}
						if($field_error == false)
							$values[$r] = $this->input->post($r, true);
					}
				}
			}
		}
		if($optional){
			foreach($optional as $o){
				$field = $this->model->get_field(array('form_id' => $id, 'name' => $o));
				if($field['display_name']){
					$display_name = $field['display_name'];
				} else {
					$display_name = $o;
				}
				if($o != ''){
					if($_POST[$o] != ''){
						$field_error = false;
						if($field['maximum_length'] > 0){
							if(strlen($_POST[$o]) > $field['maximum_length']){
								$field_error = true;
								$data['error_msg'] .= '<li>The field "' . $display_name .'" should be less than ' . $field['maximum_length'] . ' characters long.</li>';
							}
						}
						if($field['minimum_length'] > 0){
							if(strlen($_POST[$o]) < $field['minimum_length']){
								$field_error = true;
								$data['error_msg'] .= '<li>The field "' . $display_name .'" should be more than ' . $field['minimum_length'] . ' characters long.</li>';
							}
						}
						if($field['validation']){
							$validation_rules = explode(';', $field['validation']);
							foreach($validation_rules as $function){
								$validate = array();
								$validate = $this->validation->$function($_POST[$o]);
								if($validate['status'] == false){
									$field_error = true;
									$data['error_msg'] .= '<li>For the field "' . $display_name .'": '. $validate['error'] . '</li>';
								}
							}
						}
						if($field_error == false)
							$values[$o] = $this->input->post($o, true);
					}
				}
			}
		}
		
		if($data['error_msg'] == ''){
			$new_record = $this->model->save_new_record($id);
			$file_name = $form['slug'];
			$the_file = 'application/data/' . $file_name . '.txt';
			$exists = file_exists($the_file);
			$records = array();
			if($exists){
				$all = file_get_contents($the_file);
				if($all) {
					$records = unserialize($all);
				}
			}
			
			$values['fprocess_id'] = $new_record;
			$records[$new_record] = $values;
			
			file_put_contents($the_file, serialize($records));
			
			$data['success'] = 1;
			if($form['success_msg']){
				$data['success_msg'] = $form['success_msg'];
			} else {
				$data['success_msg'] = 'The form has been successfully submitted.';
			}
		} else {
			$data['error'] = 1;
		}
		
		
		$output['status'] = 1;
		$output['modal_window'] = $this->view->get('modal_window.php', $data);
		echo json_encode($output);
	}
	
	/*
	*	This generates the javascript that runs the form submission.
	*	Argument: $id - of the form to be processed
	*/
	function submit_form_js($id){
		$form = $this->model->get_form($id);
		$js_file = "$(document).ready(function(){
	$('#qform_cancel').live('click',qformCancel);
	function qformCancel(){
		$('#qform_boxes').remove();
		$('#qform_loading').remove();
	}
	$('#" . $form['form_id'] . "').live('submit', function (e){
		e.preventDefault();
		$('body').append('<div id=\"qform_loading\" style=\"width: 100%;height: 100%;\"><div style=\"z-index:900000;width: 100%;height: 100%;position: absolute;top: 0;left: 0;background: #dedede;\" id=\"qform_overlay\"></div><img id=\"qform_overlay_img\" style=\"z-index:900001;display: block;width: 126px;height: 22px;position: absolute;top: 50%;left: 50%;margin: -26px 0 0 -26px;padding: 10px;background: #fff;-moz-border-radius: 6px;border-radius: 6px;\" src=\"" . APP_BASE_URL . "images/loading10.gif\" /></div>');
		$('#qform_overlay').fadeTo(\"fast\",0.45);
		$.post('" . APP_BASE_URL . "submit_form/$id/', $('#" . $form['form_id'] . "').serialize(),function(qform_data) {
			if(qform_data.status == 1){
				$('#qform_overlay_img').remove();
				$('body').append(qform_data.modal_window);
				var winH = $(window).height();
				var winW = $(window).width();
				$('#qform_dialog').css('top',  winH/2-$('#qform_dialog').height()/2);
				$('#qform_dialog').css('left', winW/2-$('#qform_dialog').width()/2);
				$('#qform_dialog').fadeIn(2000);
				$('#qform_dialog').show();
			}
		}, \"json\");
	});
});";
		
		
		
		header("content-type: application/x-javascript");
		echo $js_file;
		echo  "\n";
		exit();
	}

	/*
	*	This is the default method. It displays the home page of the admin dashboard
	*/
	function index(){
		$this->login_check();
		$data = array();
		$data['forms'] = $this->model->get_10_forms();
		$data['no_of_forms'] = $this->model->count_forms();
		$this->view->render('home.php', $data);
	}
	
	/*
	*	This method process the form that is used to create a new form
	*/
	function new_form(){
		$this->login_check();
		$data = array();
		$data['error'] = '';
		if(isset($_POST['create'])){
			if($this->input->post('name', true) == '')
				$data['error'] .= ' The form name is required.';
			if($this->input->post('form_id', true) == '')
				$data['error'] .= ' The id attribute of the is required.';
			if(($this->input->post('required_fields', true) == '') AND ($this->input->post('optional_fields', true) == ''))
				$data['error'] .= ' The fields of the form are required.';
			
			if($data['error'] == ''){
				$slug = $this->helpers->slug($this->input->post('name', true)) . '-' . $this->helpers->random_string(4);
				$save = array('name' => $this->input->post('name', true),
								'slug' => $slug,
								'form_id' => $this->input->post('form_id', true),
								'required_fields' => $this->input->post('required_fields', true),
								'optional_fields' => $this->input->post('optional_fields', true),
								'success_msg' => $this->input->post('success_msg', true));
				$new_form_id = $this->model->create_new_form($save);
				if($new_form_id){
					$data['success'] = 'The form has been setup for processing.';
					$data['form_id'] = $new_form_id;
				} else {
					$data['error'] = 'Something went wrong. Please try again.';
				}
			}
		}
		$this->view->render('new_form.php', $data);
	}
	
	/*
	*	This method simply lists the formss paged.
	*	It is the one that is called when the admin clicks the "Manage Formss" menu in the dashboard
	*	Argument: $page - page number
	*/
	function list_forms($page = 1){
		$this->login_check();
		$rows = 30;
		$offset = ($page - 1) * $rows;
		$data = array();
		$data['forms'] = $this->model->get_paged_forms($offset, $rows);
		$data['no_of_forms'] = $this->model->count_forms();
		$data['number_of_pages'] = ceil( $data['no_of_forms'] / $rows );
		$data['page'] = $page;
		$this->view->render('list_forms.php', $data);
	}
	
	/*
	*	This method simply lists the formss paged.
	*	It is the one that is called when the admin clicks the "Manage Formss" menu in the dashboard
	*	Argument: $page - page number
	*/
	function list_forms_for_data($page = 1){
		$this->login_check();
		$rows = 30;
		$offset = ($page - 1) * $rows;
		$data = array();
		$data['forms'] = $this->model->get_paged_forms($offset, $rows);
		$data['no_of_forms'] = $this->model->count_forms();
		$data['number_of_pages'] = ceil( $data['no_of_forms'] / $rows );
		$data['page'] = $page;
		$this->view->render('list_forms_for_data.php', $data);
	}
	
	/*
	*	This method process the form used to update a forms's details
	*	Argument: $form_id - of the form
	*/
	function edit_form($form_id){
		$this->login_check();
		$data = array();
		$data['error'] = '';
		
		if(isset($_POST['delete_form'])){
			header('Location: ' . APP_BASE_URL . 'delete_form/' . $form_id . '/');
			exit();
		}
		
		if(isset($_POST['edit_form'])){
			if($this->input->post('name', true) == '')
				$data['error'] .= ' The form name is required.';
			if($this->input->post('form_id', true) == '')
				$data['error'] .= ' The id attribute of the is required.';
			if(($this->input->post('required_fields', true) == '') AND ($this->input->post('optional_fields', true) == ''))
				$data['error'] .= ' The fields of the form are required.';
			
			if($data['error'] == ''){
				$save = array('name' => $this->input->post('name', true),
								'form_id' => $this->input->post('form_id', true),
								'required_fields' => $this->input->post('required_fields', true),
								'optional_fields' => $this->input->post('optional_fields', true),
								'success_msg' => $this->input->post('success_msg', true));
				$update_form = $this->model->update_form($form_id,$save);
				if($update_form){
					$data['success'] = 'The form has been updated.';
				}
			}
		}
		
		$data['form'] = $this->model->get_form($form_id);
		$this->view->render('edit_form.php', $data);
	}
	
	/*
	*	Deletes a form
	*	Argument: $form_id - of the form
	*/
	function delete_form($form_id){
		$this->login_check();
		$data = array();
		$data['form_id'] = $form_id;
		$form = $this->model->get_form($form_id);
		if(isset($_POST['delete_form'])){
			$this->model->delete_form($form_id);
			$this->model->delete_form_records($form_id);
			$this->model->delete_field_settings($form_id);
			$file_name = $form['slug'];
			$the_file = 'application/data/' . $file_name . '.txt';
			$exists = file_exists($the_file);
			if($exists){
				unlink($the_file);
			}
			$data['success'] = 'The form has been deleted.';
		}
		$this->view->render('delete_form.php', $data);
	}
	
	/*
	*	This method displays a table of the fields for a form and allows the admin to choose one to edit
	*	Argument: $id - of the form
	*/
	function refine_fields($id){
		$this->login_check();
		$form = $this->model->get_form($id);
		$data = array();
		$data['form'] = $form;
		$data['fields'] = $this->extract_fields($form['required_fields'], $form['optional_fields']);
		$this->view->render('refine_fields.php', $data);
	}
	
	/*
	*
	*/
	function edit_field($form_id, $field_name){
		$this->login_check();
		$data = array();
		$data['error'] = '';
		if(isset($_POST['edit_field'])){
			
			if($data['error'] == ''){
				$save_validation = '';
				foreach ($_POST as $k => $v){
					if (substr($k,0,16) == "validation_rule_"){
						if($save_validation == ''){
							$save_validation .= $v;
						} else {
							$save_validation .= ';' . $v;
						}
					}
				}
				
				$save = array('display_name' => $this->input->post('display_name', true),
								'form_id' => $form_id,
								'name' => $field_name,
								'validation' => $save_validation,
								'minimum_length' => $this->input->post('minimum_length', true),
								'maximum_length' => $this->input->post('maximum_length', true));
				
				$where = array('form_id' => $form_id, 'name' => $field_name);
				
				$update_field = $this->model->save_update_field($where, $save);
				if($update_field){
					$data['success'] = 'The field has been updated.';
				}
			}
		}
		
		$data['validation_rules'] = $this->validation->get_rules();
		$data['field'] = $this->model->get_field(array('form_id' => $form_id, 'name' => $field_name));
		$data['field']['validation'] = explode(';', $data['field']['validation']);
		$data['form_id'] = $form_id;
		$data['field_name'] = $field_name;
		
		$this->view->render('edit_field.php', $data);
	}
	
	/*
	*
	*/
	function list_data($form_id, $page = 1){
		$this->login_check();
		$data = array();
		
		$form = $this->model->get_form($form_id);
		$file_name = $form['slug'];
		$the_file = 'application/data/' . $file_name . '.txt';
		$exists = file_exists($the_file);
		$records_ff = array();
		if($exists){
			$all = file_get_contents($the_file);
			if($all) {
				$records_ff = unserialize($all);
			}
		}
		
		if(isset($_POST['delete_records'])){
			$deleted = false;
			foreach ($_POST as $k => $v){
				if (substr($k,0,6) == "check_"){
					$this->model->delete_record($v);
					unset($records_ff[$v]);
					$deleted = true;
				}
			}
			file_put_contents($the_file, serialize($records_ff));
			if($deleted){
				$data['success'] = 'The record(s) was(were) successfully deleted.';
			}
		}
		
		
		$rows = 30;
		$offset = ($page - 1) * $rows;
		$records_db = $this->model->get_paged_records($form_id, $offset, $rows);
		$data['no_of_records'] = $this->model->count_records($form_id);
		$data['number_of_pages'] = ceil( $data['no_of_records'] / $rows );
		$data['page'] = $page;
		
		
		
		
		$data['records'] = array();
		foreach($records_db as $r_db){
			$data['records'][] = $records_ff[$r_db['id']];
		}
		
		
		$data['form'] = $form;
		$fields = $this->extract_fields($form['required_fields'], $form['optional_fields']);
		$data['fields'] = array();
		for($i = 0; $i < count($fields); $i++){
			if($i < 5){
				if($fields[$i])
					$data['fields'][] = $fields[$i];
			}
		}
		$this->view->render('list_data.php', $data);
	}
	
	/*
	*
	*/
	function view_data($form_id, $id){
		$this->login_check();
		$form = $this->model->get_form($form_id);
		
		
		$file_name = $form['slug'];
		$the_file = 'application/data/' . $file_name . '.txt';
		$exists = file_exists($the_file);
		$records = array();
		if($exists){
			$all = file_get_contents($the_file);
			if($all) {
				$records = unserialize($all);
			}
		}
		
		if(isset($_POST['delete_record'])){
			$this->model->delete_record($id);
			unset($records[$id]);
			file_put_contents($the_file, serialize($records));
			$data['success'] = 'The record was successfully deleted.';
		}
		
		if(!$data['success']){
			$data['record'] = $records[$id];
			$record_db = $this->model->get_record($id);
			$data['dateadded'] = $record_db['dateadded'];
		}
		
		
		
		$fields_temp = $this->extract_fields($form['required_fields'], $form['optional_fields']);
		$data['fields'] = array();
		foreach($fields_temp as $f_temp){
			$f_db = $this->model->get_field(array('form_id' => $form_id, 'name' => $f_temp));
			
			if($f_db['display_name']){
				$display_name = $f_db['display_name'];
			} else {
				$display_name = $f_temp;
			}
			$data['fields'][] = array('name'=> $f_temp, 'display_name' => $display_name);
		}
		
		$data['form'] = $form;
		$this->view->render('view_data.php', $data);
	}
	
	function extract_fields($required, $optional){
		$fields = array();
		$required = explode(',', str_replace(' ', '', $required));
		$optional = explode(',', str_replace(' ', '', $optional));
		if($required){
			foreach($required as $r){
				if($r != ''){
					$fields[] = $r;
				}
			}
		}
		if($optional){
			foreach($optional as $o){
				if($o != ''){
					$fields[] = $o;
				}
			}
		}
		return $fields;
	}
	
	/*
	*	This method check if a user is logged in as an admin. It restrics access to the methods that handle the admin dashboard
	*/
	function login_check(){	
		if(!$_SESSION['fprocess_logged_in']){
			header('Location: ' . APP_BASE_URL . 'login/');
			exit;
		} else {
			return true;
		}
	}
	
	/*
	*	THE FOLLOWING METHODS ARE FOR USER AUTHENTICATION FOR THE ADMIN DASHBOARD
	*/
	
	
	function logout(){
		unset($_SESSION['fprocess_logged_in']);
		header('Location: /');
		exit;
	}
	
	function login(){
		$data = array();
		$data['error'] = '';
		if(isset($_POST['login'])){
			$username = $this->input->post('username');
			$password = md5($this->input->post('password'));
			if(($username == APP_WEBMASTER_EMAIL) AND $this->model->check_password($password)){
				$_SESSION['fprocess_logged_in'] = true;
				header('Location: ' . APP_BASE_URL);
				exit;
			} else {
				$data['error'] = ' The login information is not correct.';
			}
		}
		$this->view->render('auth/login.php', $data);
	}
	
	function changepassword(){
		$this->login_check();
		$data = array();
		$data['error'] = '';
		if(isset($_POST['changepass'])){
			if($_POST['o_password'] == '')
				$data['error'] .= ' The old password is required.';
			if($_POST['n_password'] == '')
				$data['error'] .= ' The new password is required.';
			if($_POST['c_password'] != $_POST['n_password'])
				$data['error'] .= ' Check the new password. It was not confirmed correctly.';
			if(!$this->model->check_password(md5($this->input->post('o_password'))))
				$data['error'] .= ' The old password you entered is not correct.';
			
			if($data['error'] == ''){
				$password = md5($this->input->post('n_password'));
				$this->model->change_password($password);
				$data['success'] = 'The password has been changed. <a href="' . APP_BASE_URL . '">Click here</a> to go back to the home page.';
			}
		}
		$this->view->render('auth/change.php', $data);
	}
	
	function forgotpassword(){
		$data = array();
		if(isset($_POST['forgot'])){
			$username = $this->input->post('username');
			if($username == APP_WEBMASTER_EMAIL){
				$password = $this->generatepassword();
		
				$to = APP_WEBMASTER_EMAIL;
				$subject = "QUICK FORM PROCESSING SCRIPT";
				$message = "Your new password is: " . $password;
				$from = APP_WEBMASTER_EMAIL;
				$headers = "From: $from";
		
				$this->model->change_password(md5($password));
		
				if(mail($to,$subject,$message,$headers)){
					$data['success'] = 'The password has been reset. Check your email for the new one.';
				} else {
					$data['error'] = ' Something went wrong. Please try again.';
				}
			} else{
				$data['error'] = ' The email you entered is not correct.';
			}
		}
		$this->view->render('auth/forgot.php', $data);
	}
	
	function generatepassword($len = 8){
		$pool = '123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$str = '';
		for ($i = 0; $i < $len; $i++)
		{
			$str .= substr($pool, mt_rand(0, strlen($pool) -1), 1);
		}
		return $str;
	}
	
	function error_404(){
		$data = array();
		$this->view->render('error_404.php', $data);
	}
}
