<?php if ( ! defined('APP_ABSPATH')) exit('No direct script access allowed');
/*
*	THIS CLASS IS USED TO SANITIZE THE DATA IN THE $_POST AND $_GET VARIABLES
*/
class Input {
	private $_get = array();
	private $_post = array();
	function __construct()
	{
		parse_str($_SERVER['QUERY_STRING'], $this->_get);
		$this->_post = $_POST;
	}
	function clean($str) {
		$str = @trim($str);
		if(get_magic_quotes_gpc()) {
			$str = stripslashes($str);
		}
		return mysql_real_escape_string($str);
	}
	function get($var = NULL, $clean = true){
		if( array_key_exists($var, $this->_get) ) {
			if($clean){
				return $this->clean($this->_get[$var]);
			} else {
				return $this->_get[$var];
			}
		} else {
			return FALSE;
		}
	}
	function get_all($var = NULL, $clean = true){
		$return = array();
		if($clean){
			foreach ($this->_get as $r){
				$return[] = $this->clean($r);
			}
		} else {
			$return = $this->_get;
		}
		return $return;
	}
	function post($var = NULL, $clean = true){
		if( array_key_exists($var, $this->_post) ) {
			if($clean){
				return $this->clean($this->_post[$var]);
			} else {
				return $this->_post[$var];
			}
			
		} else {
			return FALSE;
		}
	}
	function post_all($var = NULL, $clean = true){
		$return = array();
		if($clean){
			foreach ($this->_post as $r){
				$return[] = $this->clean($r);
			}
		} else {
			$return = $this->_post;
		}
		return $return;
	}
}

class Helpers {
	function clean($str) {
		$str = @trim($str);
		if(get_magic_quotes_gpc()) {
			$str = stripslashes($str);
		}
		return mysql_real_escape_string($str);
	}
	
	function slug($str)
	{
		$str = strtolower(trim($str));
		$str = preg_replace('/[^a-z0-9-]/', '-', $str);
		$str = preg_replace('/-+/', "-", $str);
		return $str;
	}
	
	function random_string($len = 8){
		$pool = '123456789abcdefghijklmnopqrstuvwxyz';
		$str = '';
		for ($i = 0; $i < $len; $i++)
		{
			$str .= substr($pool, mt_rand(0, strlen($pool) -1), 1);
		}
		return $str;
	}
	
	
	
}

class Validation {
	
	private $rules = array('Email' => 'email',
						'Alphabetic' => 'alpha',
						'Alpha-numeric' => 'alpha_numeric',
						'Alpha-numeric with a dash' => 'alpha_numeric_dash',
						'Numeric' => 'numeric',
						'Url' => 'url');
	
	function get_rules(){
		return $this->rules;
	}
	
	
	
	function url($str){
		$return = array();
		$return['status'] = false;
		if(filter_var($str, FILTER_VALIDATE_URL)){
			$return['status'] = true;
		} else {
			$return['error'] = 'Invalid url.';
		}
		return $return;
	}
	
	function email($str){
		$return = array();
		$return['status'] = false;
		if(filter_var($str , FILTER_VALIDATE_EMAIL)){
			$return['status'] = true;
		} else {
			$return['error'] = 'Invalid email address.';
		}
		return $return;
	}
	
	function alpha($str){
		$return = array();
		$return['status'] = false;
		if(preg_match("/^([a-z])+$/i", $str)){
			$return['status'] = true;
		} else {
			$return['error'] = 'Must be alphabetic.';
		}
		return $return;
	}
	
	function alpha_numeric($str){
		$return = array();
		$return['status'] = false;
		if(preg_match("/^([a-z0-9])+$/i", $str)){
			$return['status'] = true;
		} else {
			$return['error'] = 'Must be alpha-numeric.';
		}
		return $return;
	}
	
	function alpha_numeric_dash($str){
		$return = array();
		$return['status'] = false;
		if(preg_match("/^([-a-z0-9_-])+$/i", $str)){
			$return['status'] = true;
		} else {
			$return['error'] = 'Must be alpha-numeric or dash.';
		}
		return $return;
	}
	
	function numeric($str){
		$return = array();
		$return['status'] = false;
		if(preg_match( '/^[\-+]?[0-9]*\.?[0-9]+$/', $str)){
			$return['status'] = true;
		} else {
			$return['error'] = 'Must be numeric.';
		}
		return $return;
	}
	
	
	
}