<?php if ( ! defined('APP_ABSPATH')) exit('No direct script access allowed');
/*
*	ALL THE INTERACTIONS WITH THE DATABASE ARE HANDLED IN THIS CLASS
*/
class Model {
	var $db_connection;
	var $forms_table;
	var $fields_table;
	var $users_table;
	var $records_table;
	
	
	// The constructor method opend the database connection
	function __construct(){
		$this->forms_table = APP_TABLES_PREFIX . 'forms';
		$this->fields_table = APP_TABLES_PREFIX . 'fields';
		$this->users_table = APP_TABLES_PREFIX . 'users';
		$this->records_table = APP_TABLES_PREFIX . 'records';
		
		
		$result = false;
		$this->db_connection = mysql_connect(APP_DB_HOST, APP_DB_USER, APP_DB_PASSWORD);
		if($this->db_connection){
			$seldb = mysql_select_db(APP_DB_NAME,$this->db_connection);
			if($seldb){
				$result = true;
			}  else {
				if($this->show_errors)
					die(mysql_error());
			}
		} else {
			if($this->show_errors)
				die(mysql_error());
		}
		return $result;
	}
	
	function disconnect() {
		return  mysql_close($this->db_connection);
	}
	
	/*
	*	THE FOLLOWING ARE THE METHODS CALLED FROM THE CONTROLLER CLASS.
	*	THEIR NAMES EXPRESS WHAT THEY DO.
	*	THEY ALL MAKE USE A CRUD METHOD FOR SELECT, UPDATE, INSERT AND DELETE AT THE END PARTS OF THIS CLASS
	*/
	function create_new_form($values){
		return $this->insert($this->forms_table, $values);
	}
	function get_10_forms(){
		$limit = array('offset' => 0, 'rows' => 5);
		return $this->select($this->forms_table, '*', null, null, $limit, $condition = 'AND');
	}
	function get_paged_forms($offset, $rows){
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->forms_table, '*', null, null, $limit, $condition = 'AND');
	}
	function count_forms(){
		return count($this->select($this->forms_table, 'id'));
	}
	function get_form($id){
		$where = array('id' => $id);
		$results = $this->select($this->forms_table, '*', $where, null, null, $condition = 'AND');
		return $results['0'];
	}
	function update_form($id, $values){
		$where = array('id' => $id);
		return $this->update($this->forms_table, $values, $where, $condition = 'AND');
	}
	function delete_form($id){
		$where = array('id' => $id);
		return $this->delete($this->forms_table, $where, $condition = 'AND');
	}
	
	function save_new_record($form_id){
		$values = array('form_id' => $form_id, 'dateadded' => time());
		return $this->insert($this->records_table, $values);
	}
	function get_field($where){
		$results = $this->select($this->fields_table, '*', $where, null, null, $condition = 'AND');
		return $results['0'];
	}
	function save_update_field($where, $values){
		$results = $this->select($this->fields_table, '*', $where, null, null, $condition = 'AND');
		if($results['0']){
			return $this->update($this->fields_table, $values, $where, $condition = 'AND');
		} else {
			return $this->insert($this->fields_table, $values);
		}
	}
	function delete_field_settings($id){
		$where = array('form_id' => $id);
		return $this->delete($this->fields_table, $where, $condition = 'AND');
	}
	
	function get_paged_records($form_id, $offset, $rows){
		$where = array('form_id' => $form_id);
		$limit = array('offset' => $offset, 'rows' => $rows);
		return $this->select($this->records_table, '*', $where, null, $limit, $condition = 'AND');
	}
	function count_records($form_id){
		$where = array('form_id' => $form_id);
		return count($this->select($this->records_table, 'id', $where));
	}
	function delete_record($id){
		$where = array('id' => $id);
		return $this->delete($this->records_table, $where, $condition = 'AND');
	}
	function delete_form_records($id){
		$where = array('form_id' => $id);
		return $this->delete($this->records_table, $where, $condition = 'AND');
	}
	function get_record($id){
		$where = array('id' => $id);
		$results = $this->select($this->records_table, '*', $where, null, null, $condition = 'AND');
		return $results['0'];
	}
	
	function check_password($password){
		$results = $this->select($this->users_table, '*', null, null, null, $condition = 'AND');
		$save_password = $results['0']['password'];
		if($save_password == $password){
			return true;
		} else {
			return false;
		}
	}
	
	function change_password($password){
		$results = $this->select($this->users_table, '*', null, null, null, $condition = 'AND');
		$id = $results['0']['id'];
		
		$values = array('password' => $password);
		$w = array('id' => $id);
		return $this->update($this->users_table, $values, $w, $condition = 'AND');
	}
	
/*
* CRUD FUNCTIONS:  The following functions can be used to make interacting with the database easier
*/
	
	function tableExists($table)
    {
        $tablesInDb = mysql_query('SHOW TABLES FROM '.APP_DB_NAME.' LIKE "'.$table.'"');
        if($tablesInDb){
            if(mysql_num_rows($tablesInDb)==1){
                return true;
            } else {
                return false;
            }
        }
    }
	
	/*
	* This function selects one or more records from a table
	* It takes the following arguments:
	* 		- $table - the table to select from
	*		- $rows_to_select - a string of the rows to select for example "id, name, time,..."
	*		- $where_keys_values - an array where the keys are field names and the values are the values of those fields. This is for the WHERE part of the query
	*		- $order_by - an array where the keys are field names and the values are the direction to order them in. This is for the ORDER BY part of the query.
	*		- $limit - an array like this array('offset'=>0, 'rows'=>10)
	*		- $condition - the condition to be used for the where part of the query
	*/
	
	function select($table, $rows_to_select = '*', $where_keys_values = null, $order_by = null, $limit = null, $condition = 'AND')
    {
        $results = array();
		$q = 'SELECT '.$rows_to_select.' FROM '.$table;
		
		if($where_keys_values != null){
			$where_str = $this->where_array_to_string($where_keys_values, $condition);
			$q .= ' WHERE '.$where_str;
		}
		
		if($order_by != null){
			$order_by_fields = array_keys($order_by);
			$order_by_direction = array_values($order_by);
			$order_by_str = '';
			
			for($i = 0; $i < count($order_by); $i++){
				$order_by_str .= $order_by_fields[$i] . ' ';
				$order_by_str .= $order_by_direction[$i] . ' ';
				if($i != count($order_by)-1) {
                    $order_by_str .= $condition . ', ';
                }
			}
			$q .= ' ORDER BY '.$order_by_str;
		}
		
		if($limit != null){
			$offset = $limit['offset'];
			$rows = $limit['rows'];
			$q .= "  LIMIT $offset, $rows";
		}
		
		$query = mysql_query($q);
        if($query){
            $numResults = mysql_num_rows($query);
            for($i = 0; $i < $numResults; $i++){
				$row = mysql_fetch_array($query);
				$results[] =  $row;
			}
			
		}
		return $results;
	}
	
	/*
	*This function creates a new MySql records.
	*It takes two arguments:
	*		- $table: the table to insert into
	*		- $keys_values: the values to insert. The keys of the array should be the field names
	*It return the id of the new record
	*/
	function insert($table, $keys_values)
    {
        if($this->tableExists($table)){
            $insert = 'INSERT INTO '.$table;
            $rows = array_keys($keys_values);
			$rows = implode(', ',$rows);
			
			if($rows != null){
                $insert .= ' ('.$rows.')';
            }
			
			$values = array_values($keys_values);

            for($i = 0; $i < count($values); $i++){
                if(is_string($values[$i]))
                    $values[$i] = '"'.$values[$i].'"';
            }
            $values = implode(', ',$values);
            $insert .= ' VALUES ('.$values.')';

            $ins = mysql_query($insert);

            if($ins){
                return mysql_insert_id();
            } else {
                return 0;
            }
        }
    }
	
	
    /*
	*This function updates the database with the values sent
	*It takes four arguments:
	*		- $table: the table to insert into
	*		- $keys_values: the values to update. The keys of the array should be the field names
	*		- $where_keys_values: the values for the WHERE part of the query. The keys of the array should be the field names
	*		- $condition: AND or OR
	*It return true or false
	*/
    function update($table, $keys_values, $where_keys_values, $condition = 'AND')
    {
        if($this->tableExists($table))
        {
            $where_str = $this->where_array_to_string($where_keys_values, $condition);
			
			$update = 'UPDATE '.$table.' SET ';
            $keys = array_keys($keys_values);
            for($i = 0; $i < count($keys_values); $i++) {
                if(is_string($keys_values[$keys[$i]])) {
                    $update .= $keys[$i].'="'.$keys_values[$keys[$i]].'"';
                } else {
                    $update .= $keys[$i].'='.$keys_values[$keys[$i]];
                }
				if($i != count($keys_values)-1) {
                    $update .= ',';
                }
            }
			
			
            $update .= ' WHERE '.$where_str;
			$query = mysql_query($update);
            if($query){
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
	
	/*
	*This function simply deletes a table or records
	*If the $where_keys_values argument is not provided then the whole table is deleted
	*/
	function delete($table, $where_keys_values = null, $condition = 'AND')
    {
        if($this->tableExists($table)){
            if($where_keys_values != null){
                $where_str = $this->where_array_to_string($where_keys_values, $condition);
				$delete = 'DELETE FROM '.$table.' WHERE '.$where_str;
				$del = mysql_query($delete);
				if($del) {
					return true;
				} else {
					return false;
				}
			}
        }
		return false;
    }
	
	/*
	*	This method converts an array that has field names and values to a string that can be put in the WHERE section of a mysql query
	*	It also places the condition (AND || OR) in the string
	*/
	function where_array_to_string($where_keys_values, $condition){
		$where_fields = array_keys($where_keys_values);
		$where_values = array_values($where_keys_values);
		$where_str = '';
			
		for($i = 0; $i < count($where_keys_values); $i++){
			$where_str .= $where_fields[$i] . ' = ';
			if(is_string($where_values[$i])){
				$where_str .= '"' . $where_values[$i] . '" ';
			} else {
				$where_str .= $where_values[$i] . ' ';
			}
			if($i != count($where_keys_values)-1) {
				$where_str .= $condition . ' ';
			}
		}
		
		return $where_str;
	}
}