/**
 * buttonGenerator
 *
 * author: Andrei Dinca
 * email: andrei.webdeveloper@gmail.com
 *
 * version 1.0 release date: 23.11.2010
 *
**/
var buttonGenerator = {
    o: {
        element : 'div.style', // slideshow html element
        buttonElm : '.button'
    },
	
    // just init
    option:{},
	
    init: function(customOption) {
        var self = this;
		
        // extend default option
        self.option = $.extend({}, self.o, customOption);
		
        // oveserv and init color swich
        self.styleSwich();
		
        // init color piker
        self.colorPicker();
		
        // init ownColor observer
        self.ownColor();
		
        // int initLoweRezolution observer
        self.initLoweRezolution();
    },
	
    styleSwich: function(){
        var self = this;
		
        $(self.option.element).click(function(){
            var $this = $(this);
			
            // remove last on
            $(self.option.element).parent('div').find('.on').removeClass('on');
			
            // set current selected
            $this.addClass('on');
			
            // remove all other color class
            self.removeClasss();
            
            // add custom class
            $(self.option.buttonElm).not('.minimal').addClass($this.find('span').attr('class'));
        });
    },
	
    colorPicker: function(){
        var self = this;
		
        $('#ownColor-normal input:text').ColorPicker({
            onSubmit: function(hsb, hex, rgb, el) {
                $(el)
                .val(hex)
                .ColorPickerHide()
                .css("background-color", "#" + hex);
            },
            onBeforeShow: function () {
                $(this).ColorPickerSetColor(this.value).css("background-color", "#" + this.value);
            }
        })
        .bind('keyup', function(){
            $(this).ColorPickerSetColor(this.value);
        });
    },
	
    ownColor: function(){
        var self = this;

        $("#ownColor-normal").submit(function(){
            var collors_normal = {
                'border'            : $("#colorpicker-normal-border").val(),
                'background_color'  : $("#colorpicker-normal-background-color").val(),
                'gradient_from'     : $("#colorpicker-normal-gradient-from").val(),
                'gradient_to'       : $("#colorpicker-normal-gradient-to").val(),
                'text_shadow'       : $("#colorpicker-normal-text-shadow").val(),
                'color'             : $("#colorpicker-normal-color").val()
            };

            var str = '';
            str += "/* Your custom color */ \n .button.customColor { \n";
            str += "\t border: 1px solid #" + collors_normal.border + ";\n";
            str += "\t background-color: #" + collors_normal.background_color + ";\n";	
             
            str += "\t  /* css 3 */ \n";	
            str += "\t background-image: -webkit-gradient(linear, 0 0, 0 100%, from(#" + collors_normal.gradient_from + "), to(#" + collors_normal.gradient_to + "));\n";
            str += "\t background-image: -moz-linear-gradient(#" + collors_normal.gradient_from + ", #" + collors_normal.gradient_to + "); \n";
            str += "\t background-image: -o-linear-gradient(#" + collors_normal.gradient_from + ", #" + collors_normal.gradient_to + "); \n";
            str += "\t background-image: linear-gradient(#" + collors_normal.gradient_from + ", #" + collors_normal.gradient_to + "); \n";
			
            str += "\t filter:  progid:DXImageTransform.Microsoft.gradient(GradientType=0,startColorstr='#" + collors_normal.collors_normal + "', endColorstr='#" + collors_normal.gradient_to + "'); /* IE6 & IE7 */ \n";
            str += "\t -ms-filter: \"progid:DXImageTransform.Microsoft.gradient(GradientType=0,startColorstr='#" + collors_normal.gradient_from + "', endColorstr='#" + collors_normal.gradient_to + "')\"; /* IE8 */ \n";
            
            str += "\t  /* text */ \n";
            str += "\t text-shadow: 1px 1px 0 #" + collors_normal.text_shadow + " ;\n";
            str += "\t color: #" + collors_normal.color + "; }\n";
            
            
            var collors_hover = {
                'border'            : $("#colorpicker-hover-border").val(),
                'border_botom'            : $("#colorpicker-hover-border-bottom-color").val(),
                'background_color'  : $("#colorpicker-hover-background-color").val(),
                'gradient_from'     : $("#colorpicker-hover-gradient-from").val(),
                'gradient_to'       : $("#colorpicker-hover-gradient-to").val(),
                'text_shadow'       : $("#colorpicker-hover-text-shadow").val(),
                'color'             : $("#colorpicker-hover-color").val()
            };
            
            /* active */
            str += "\n\n /* Your custom color */ \n .button.customColor:hover, \n";
            str += ".button.customColor:focus,  \n";
            str += ".button.customColor:active,  \n";
            str += ".button.customColor.on { \n";
            
            str += "\t border: 1px solid #" + collors_hover.border + ";\n";
            str += "\t border-bottom-color: #" + collors_hover.border_botom + ";\n";
            str += "\t background-color: #" + collors_hover.background_color + ";\n";	
             
            str += "\t  /* css 3 */ \n";	
            str += "\t background-image: -webkit-gradient(linear, 0 0, 0 100%, from(#" + collors_hover.gradient_from + "), to(#" + collors_hover.gradient_to + "));\n";
            str += "\t background-image: -moz-linear-gradient(#" + collors_hover.gradient_from + ", #" + collors_hover.gradient_to + "); \n";
            str += "\t background-image: -o-linear-gradient(#" + collors_hover.gradient_from + ", #" + collors_hover.gradient_to + "); \n";
            str += "\t background-image: linear-gradient(#" + collors_hover.gradient_from + ", #" + collors_hover.gradient_to + "); \n";
			
            str += "\t filter:  progid:DXImageTransform.Microsoft.gradient(GradientType=0,startColorstr='#" + collors_hover.gradient_from + "', endColorstr='#" + collors_hover.gradient_to + "'); /* IE6 & IE7 */ \n";
            str += "\t -ms-filter: \"progid:DXImageTransform.Microsoft.gradient(GradientType=0,startColorstr='#" + collors_hover.gradient_from + "', endColorstr='#" + collors_hover.gradient_to + "')\"; /* IE8 */ \n";
            
            str += "\t  /* text */ \n";
            str += "\t text-shadow: 1px 1px 0 #" + collors_hover.text_shadow + " ;\n";
            str += "\t color: #" + collors_hover.color + "} \n";
             

            // print css to style html tag
            $("style").html(str);
            
            // remove all other color class
            self.removeClasss();
            
            // add custom class
            $(self.option.buttonElm).not('.minimal').addClass('customColor');
            
            // prevent refresh of page
            return false;
        });
		
        $("#getCode").click(function(){
		
            var collors = {
                'top'		: $("#colorpicker-top").val(),
                'middle'	: $("#colorpicker-middle").val(),
                'bottom'	: $("#colorpicker-bottom").val()
            };

            $("#getCodeConsole, #fade").remove();
            $("body").append('<div id="getCodeConsole"><h2>Copy your source code:</h2> <span class="close"> Close </span> <pre id="cssCode" style="background-color: #e3e9ec;padding: 4px;"></pre></div>');
            $("#getCodeConsole").css({
                'width'			: '940px',
                'height'		: '650px',
                'overflow'		: 'auto',
                'padding'		: '10px',
                'position'		: 'absolute',
                'top'			: '20%',
                'left'			: '50%',
                'margin-left'           : '-480px',
                'z-index'		: 10000001
            });
			
            $("body").append('<div id="fade"></div>');
            $("#fade").css({
                'width'			: '100%',
                'height'		: '100%',
                'position'		: 'absolute',
                'top'			: '0%',
                'left'			: '0%',
                'background'	: '#000',
                'opacity'		: 0.8,
                'z-index'		: 10000000
            });
			
			
            $("#cssCode").html($("style").text());
            return false;
        });
		
        // live because in document ready elements ".close" not exist
        $("#getCodeConsole .close, #fade").live('click',function(){
            $("#getCodeConsole").fadeOut(400);
            $("#fade").fadeOut(100);
            return false;
        });
    },
    
    removeClasss: function() {
         var self = this;
         $(self.option.buttonElm)
            .not('.minimal')
            .removeClass('customColor')
            .removeClass('blue')
            .removeClass('green')
            .removeClass('blue')
			.removeClass('black')
            .removeClass('red');
    },
    
    initLoweRezolution: function(){
        if($(window).width() < 1512){
            $("div.colorSwich").css({
                zIndex: 2,
                left: "-220px"
            });
			
            $(".colorpicker").css('z-index', 1000);
			
            $(".slideBtn").click(function(){	
                if(parseInt($("div.colorSwich").css('left'), 10) < 0){
                    $("div.colorSwich").css('left', '10px');
                    $(this).removeClass('open').addClass('close');
                }else{
                    $("div.colorSwich").css('left', "-220px");
                    $(this).removeClass('close').addClass('open');
                }
                return false;
            });
        }else{
            $("div.colorSwich").find('.slideBtn').remove();
        }
    }
};
$(document).ready(function(){
    buttonGenerator.init();
});