(function ($) {
    $.fn.jHoriSlide = function (k) {
        var s = $(this);
        var c = $.extend({
            maxSliderImages: '5',
            reduceSliderWidth: '20',
            Sliderspacing: '10',
            easing: 'swing',
            z_index: '100',
            autoAnimate: '1',
            autoAnimateDelay: '6000',
            PlayIfDisabled: '1',
            wrapper: '#layer',
            buttonStartStop: '.playpause',
            buttonNext: '.next',
            speed: '600',
            stoponClick: '1'
        }, k);
        s.methods = {
            sort_slider: function (a, i) {
                var b = c.z_index - l;
                $(a).find('img').css('visibility', 'hidden');
                if (l < c.maxSliderImages) {
                    var d = c.reduceSliderWidth * l;
                    $(a).find('img').css({
                        'z-index': b,
                        'opacity': (1 / c.maxSliderImages) * (x + 1),
                        'width': sliderArray[i].width - d,
                        'height': (sliderArray[i].height / sliderArray[i].width) * (sliderArray[i].width - d),
                        'left': d / 2,
                        'top': c.Sliderspacing * x,
                        'visibility': 'visible'
                    });
                    $(a).addClass('shown');
                    b++;
                    x++
                }
                if (l == 0) {
                    $(a).addClass('first')
                }
                l--
            },
            animateSlider: function (a) {
                if (isRunning == 0) {
                    isRunning = 1;
                    var x = 1;
                    var b = c.maxSliderImages;
                    var d = parseInt($('li.first').find('img').css('top'));
                    if ((sliderArray.length - c.maxSliderImages) == 0) {
                        $('li.first').find('img').animate({
                            'opacity': '0',
                            'top': d + parseInt(c.Sliderspacing)
                        }, c.speed, c.easing)
                    } else {
                        $('li.first').find('img').animate({
                            'opacity': '0',
                            'top': d + parseInt(c.Sliderspacing)
                        }, c.speed, c.easing, function () {
                            $(this).css('visibility', 'hidden')
                        })
                    }
                    $('li.first').removeClass('shown').removeClass('first');
                    sliderArray.unshift(sliderArray[sliderArray.length - 1]);
                    sliderArray.pop();
                    for (var i = 0; i < sliderArray.length; i++) {
                        if (i >= (sliderArray.length - c.maxSliderImages)) {
                            var e = 'li.' + sliderArray[i].classes;
                            d = c.Sliderspacing * (x - 1);
                            var f = ((1 / c.maxSliderImages) * x) * 10000;
                            f = Math.round(f);
                            f = f / 10000;
                            var g = c.reduceSliderWidth * (b - 1);
                            var h = sliderArray[i].width - g;
                            var j = (sliderArray[i].height / sliderArray[i].width) * h;
                            if (i == (sliderArray.length - c.maxSliderImages)) {
                                $(e).find('img').css({
                                    'top': '-10px',
                                    'opacity': 1,
                                    'visibility': 'visible',
                                    'width': 0,
                                    'height': 0,
                                    left: h / 2
                                })
                            }
                            $(e).find('img').animate({
                                'top': d,
                                'opacity': f,
                                'width': h,
                                'height': j,
                                'left': g / 2
                            }, c.speed, c.easing, function () {
                                isRunning = 0
                            });
                            $(e).find('img').css('z-index', c.z_index - b);
                            $(e).addClass('shown');
                            if (i == (sliderArray.length - 1)) {
                                $(e).addClass('first')
                            }
                            b--;
                            x++
                        }
                    }
                }
            },
            autoSlide: function (a, b) {
                interval = window.setInterval(function () {
                    s.methods.animateSlider(a)
                }, b)
            },
            StartStop: function () {
                if (stopped == 0) {
                    stopped = 1;
                    $(c.buttonStartStop).addClass('play').removeClass('pause')
                } else if (stopped == 1) {
                    stopped = 0;
                    $(c.buttonStartStop).addClass('pause').removeClass('play')
                }
                if (stopped == 1) {
                    window.clearInterval(interval)
                }
                if (stopped == 0) {
                    s.methods.autoSlide(s.find('li'), c.autoAnimateDelay)
                }
            },
            prepare: function () {
                s.find('img').each(function (i) {
                    $(this).css('position', 'absolute')
                });
                s.css('list-style-type', 'none');
                s.find('li').each(function (i) {
                    $(this).addClass('slider_' + i)
                });
                sliderArray = new Array();
                s.find('li').each(function (i) {
                    sliderArray[i] = new Object();
                    if (window.opera) {
                        sliderArray[i].width = parseInt($(this).find('img').attr('width'));
                        sliderArray[i].height = parseInt($(this).find('img').attr('height'))
                    } else {
                        sliderArray[i].width = parseInt($(this).find('img').css('width'));
                        sliderArray[i].height = parseInt($(this).find('img').css('height'))
                    }
                    sliderArray[i].classes = $(this).attr('class')
                });
                l = sliderArray.length - 1;
                x = 0;
                s.find('li').each(function (i) {
                    s.methods.sort_slider(this, i)
                });
                s.parent().css('left', parseInt($(c.wrapper).css('width')) / 2 - sliderArray[0].width / 2);
                if (c.autoAnimate == 0) {
                    $(c.buttonStartStop).removeClass('pause').addClass('play')
                } else {
                    $(c.buttonStartStop).addClass('pause').removeClass('play')
                }
            },
            next: function () {
                if (c.autoAnimate == 1 && stopped == 0) {
                    window.clearInterval(interval)
                }
                s.methods.animateSlider(s.find('li'));
                if (c.autoAnimate == 1 && stopped == 0) {
                    s.methods.autoSlide(s.find('li'), c.autoAnimateDelay)
                }
            },
            init: function () {
                s.methods.prepare();
                isRunning = 0;
                $(c.buttonNext).click(function () {
                    s.methods.next()
                });
                if (c.autoAnimate == 1 || c.PlayIfDisabled == 1) {
                    stopped = 0;
                    $(c.buttonStartStop).click(function () {
                        s.methods.StartStop()
                    })
                }
                if (c.stoponClick == 1) {
                    s.find('img').click(function () {
                        if (stopped == 0) {
                            s.methods.StartStop()
                        }
                    })
                }
                if (c.autoAnimate == 1) {
                    s.methods.autoSlide(s.find('li'), c.autoAnimateDelay)
                } else {
                    stopped = 1
                }
            }
        };
        var l;
        s.methods.init()
    }
})(jQuery);