/*
 * Photoshelf - jQuery gallery
 * elegant gallery with zoom feature
 *
 * Documentation included in package bought on CodeCanyon
 * 
 * Copyright (c) 2010 Rezoner Sikorski
 *
 * Version: 1.0.1 (20/10/2010)
 * Requires: jQuery v1.42+
 *
 */
(function ($) {
    var config = {};
    var defaults = {
        zoomHeight: 200,
        variations: 6,
        style: "default"
    };
    var screenWidth;

    function echo(m) {
        $("#console").append(m);
    }

    function setup($o, args) {
        var lastImage = new Image();
        $(lastImage).load(function () {
            var $photos = $o.children();
            var $photoshelfZoom = $("#photoshelf-zoom");
            var options = $.extend({}, defaults, args);
            $o.removeClass("photoshelf-no-js");
            $o.addClass("photoshelf");
            $o.addClass("photoshelf-" + options.style);
            options.zoomWidth = $o.outerWidth() - 2;
            var photoWidth = 0;
            var photoHeight = 0;
            var zoomImageWidth = 0;
            var zoomImageHeight = 0;
            var zoomReady = false;
            var zoomScaleX = 0;
            var zoomScaleY = 0;
            var animatingPhoto = false;
            var overlayTimer = null;
            screenWidth = $(window).width();
            var data = {
                anchorHeight: $o.children(":last").children().outerHeight()
            }
            $o.css({
                height: data.anchorHeight
            });
            $o.find("h2").css({
                height: data.anchorHeight
            });
            data.photoshelfZoomTop = $o.offset().top + data.anchorHeight + 1
            if ($.browser.msie) {
                data.duration = 0;
            } else data.duration = 300;
            $o.before("<div class='photoshelf-overlay'></div>");
            $o.prev(".photoshelf-overlay").css({
                opacity: 0.6
            });
            $o.data("photoshelf-data", data);
            $photos.find("a img").hover(function () {}, function () {
                if (zoomReady && !animatingPhoto) $photoshelfZoom.children(".desc:first").slideDown(300);
                $(this).parent().children('.pan-screen').remove();
                $(this).animate({
                    'opacity': 1.0
                }, 500);
            });
            $photos.find("a img").mousemove(function (e) {
                if (!zoomReady || animatingPhoto) return false;
                $this = $(this);
                var bgx = -zoomScaleX * (-16 + e.pageX - $this.offset().left);
                var bgy = -zoomScaleY * (-16 + e.pageY - $this.offset().top);
                if (bgx > 0) bgx = 0;
                if (bgy > 0) bgy = 0;
                if ((bgy - options.zoomHeight) < -zoomImageHeight) bgy = -zoomImageHeight + options.zoomHeight;
                if ((bgx - options.zoomWidth) < -zoomImageWidth) bgx = -zoomImageWidth + options.zoomWidth;
                $photoshelfZoom.css({
                    "background-position": (zoomImageWidth < options.zoomWidth ? 'center' : bgx + "px") + " " + (zoomImageHeight < options.zoomHeight ? 'center' : bgy + "px")
                });
                if (!$this.prev().hasClass('pan-screen')) {
                    $photoshelfZoom.children(".desc:first").slideUp(500);
                    $this.before("<span class='pan-screen'><span class='pan'></span></span>");
                    $this.parent().children('.pan-screen').css({
                        width: $this.width(),
                        height: $this.height()
                    }).children().css({
                        background: "url(" + $this.attr('src') + ")"
                    }).animate({
                        height: $this.height() / zoomImageHeight * options.zoomHeight,
                        width: $this.width() / zoomImageWidth * options.zoomWidth,
                    }, 500).hide().fadeIn(500);
                    $(this).animate({
                        'opacity': 0.5
                    }, 300);
                }
                var px = (-bgx / zoomImageWidth) * photoWidth;
                var py = (-bgy / zoomImageHeight) * photoHeight;
                $(this).prev().children().css({
                    left: px,
                    top: py,
                    "background-position": (-px) + "px " + (-py) + "px"
                });
            });
            var photosCount = $photos.size();
            var photosContainerWidth = $o.innerWidth() - $o.children(":last").outerWidth();
            var photosWidth = 0;
            $photos.each(function (i, o) {
                photosWidth += $(o).outerWidth();
            });
            var photoMargin = photosContainerWidth / (photosCount - 1);
            $photos.each(function (i, o) {
                var $o = $(o);
                $o.css({
                    marginLeft: photoMargin * i
                })
                if ($o.get(0).tagName != 'H2') $o.addClass("photo-" + (i % options.variations));
                $o.children('a').attr('tooltip', $o.children('a').attr('title'));
                $o.children('a').removeAttr('title');
            });
            $photos.mouseenter(function () {
                var data = $o.data("photoshelf-data");
                clearTimeout(overlayTimer);
                animatingPhoto = true;
                $(this).addClass('hover').css({
                    height: data.anchorHeight * 2,
                    marginTop: -data.anchorHeight
                });
                $(this).children('a').css({
                    marginTop: data.anchorHeight
                }).animate({
                    marginTop: 0
                }, data.duration, function () {
                    animatingPhoto = false;
                    var $this = $(this);
                    $photoshelfZoom.css({
                        width: options.zoomWidth,
                        height: options.zoomHeight,
                        "background-position": "center center"
                    });
                    $photoshelfZoom.children('.desc').css({
                        'opacity': 0.75,
                        height: 'auto',
                        padding: 8
                    }).hide().html($this.attr('tooltip'));
                    zoomReady = false;
                    var zoomLeft = $this.offset().left + $this.outerWidth();
                    if (zoomLeft > screenWidth / 2) zoomLeft = $this.offset().left - options.zoomWidth
                    $photoshelfZoom.css({
                        left: $this.parent().parent().offset().left,
                        top: data.photoshelfZoomTop
                    });
                    photoWidth = $this.find("img:first").width();
                    photoHeight = $this.find("img:first").height();
                    if ($this.parent().hasClass('hover')) $("#photoshelf-zoom").addClass('loader').fadeIn(300);
                    var img = new Image();
                    $photoshelfZoom.children(".desc:first").hide();
                    $(img).load(function () {
                        if (!$this.parent().hasClass('hover')) {
                            $this.children('.loader').remove();
                            $(img).remove();
                            return false;
                        }
                        overlayTimer = setTimeout(function () {
                            if (!$.browser.msie) $o.prev(".photoshelf-overlay").stop().fadeIn(300);
                        }, 300);
                        zoomImageWidth = img.width;
                        zoomImageHeight = img.height;
                        zoomScaleX = (zoomImageWidth - options.zoomWidth) / (photoWidth - 32);
                        zoomScaleY = (zoomImageHeight - options.zoomHeight) / (photoHeight - 32);
                        zoomReady = true;
                        $photoshelfZoom.children(".desc:first").hide().stop().slideDown(300);
                        $photoshelfZoom.css({
                            "border-color": $this.parent().css('border-color'),
                            "background-image": "url(" + $this.attr('rel') + ")"
                        }).removeClass('loader');
                        $this.children('.loader').fadeOut(300, function () {
                            $(this).remove();
                        });
                        $(img).remove();
                    });
                    img.src = $this.attr('rel');
                });
            });
            $photos.mouseleave(function () {
                var data = $o.data("photoshelf-data");
                $this = $(this);
                $this.children('a').stop().animate({
                    marginTop: 0
                }, data.duration);
                $this.removeClass('hover').animate({
                    height: data.anchorHeight,
                    marginTop: 0
                }, data.duration);
                $photoshelfZoom.stop().css({
                    opacity: 1
                }).hide();
                $this.children('.loader').hide().remove();
                clearTimeout(overlayTimer);
                overlayTimer = setTimeout(function () {
                    $o.prev(".photoshelf-overlay").fadeOut(data.duration);
                }, 500);
            });
        });
        lastImage.src = $o.children(':last').find('img').attr('src');
    }
    $.photoshelf = function (command, options) {
        switch (command) {
        case 'config':
            config = $.extend({}, config, options);
            break;
        case 'defaults':
            defaults = $.extend({}, defaults, options);
            break;
        };
    }
    $.fn.photoshelf = function (command, options) {
        if (typeof command == 'object') {
            return this.each(function (i, o) {
                setup($(o), command);
            });
        } else {
            if (typeof options != 'object') options = {}
            options.type = command;
            return this.each(function (i, o) {
                setup($(o), options);
            });
        };
    };
    $(function () {
        $("body").append('<div id="photoshelf-zoom"><div class="desc"></div></div>');
    });
})(jQuery);