<?php

class Account_Model_Validator extends Artisan_Controller_Model_Validator {

	public function init($model) {
		$this->_model = array(
			'register' => array(
				'firstname' => array('label' => _('First Name'), 'rule_list' => array('not_empty' => true, 'max_length' => 64)),
				'lastname' => array('label' => _('Last Name'), 'rule_list' => array('not_empty' => true, 'max_length' => 64)),
				'email_address' => array('label' => _('Email Address'), 'rule_list' => array('not_empty' => true, 'email' => true, 'max_length' => 255)),
				'username' => array('label' => _('Username'), 'rule_list' => array('not_empty' => true, 'max_length' => 32)),
				'password' => array('label' => _('Password'), 'rule_list' => array('not_empty' => true, 'min_length' => 6)),
				'password_repeat' => array('label' => _('Repeated Password'), 'rule_list' => array('not_empty' => true, 'min_length' => 6)),
				'gender' => array('label' => _('Gender'), 'rule_list' => array('not_empty' => true, 'in_array' => array(GENDER_FEMALE, GENDER_MALE)))
			),
			'profile-business' => array(
				'time_offset' => array('label' => _('Time Zone Offset'), 'rule_list' => array()),
				'username' => array('label' => _('Username'), 'rule_list' => array('not_empty' => true, 'max_length' => 32)),
				'firstname' => array('label' => _('First Name'), 'rule_list' => array('not_empty' => true, 'max_length' => 64)),
				'lastname' => array('label' => _('Last Name'), 'rule_list' => array('not_empty' => true, 'max_length' => 64)),
				'company' => array('label' => _('Company'), 'rule_list' => array('max_length' => 64)),
				'comments' => array('label' => _('Comments'), 'rule_list' => array()),
				'url' => array('label' => _('Full URL'), 'rule_list' => array()),
				'twitter' => array('label' => _('Twitter Account'), 'rule_list' => array()),
				'facebook' => array('label' => _('Facebook Profile'), 'rule_list' => array()),
				'linkedin' => array('label' => _('LinkedIn Profile'), 'rule_list' => array()),
				'posterous' => array('label' => _('Posterous Blog'), 'rule_list' => array()),
				'tumblr' => array('label' => _('Tumblr Blog'), 'rule_list' => array())
			),
			'message' => array(
				'subject' => array('label' => _('Subject'), 'rule_list' => array('not_empty' => true, 'max_length' => 128)),
				'message' => array('label' => _('Message'), 'rule_list' => array('not_empty' => true, 'max_length' => 4096))
			)
		);

		if ( true === asfw_exists($model, $this->_model) ) {
			$this->_model_name = $model;
		}
	}
}