<?php

require_once 'application/Root/Root.php';

class Page_Controller extends Root_Controller {

	public function viewGet($name) {
		try {
			$result_page = PV::getDb()->select()
				->from('page')
				->where('name = ?', $name)
				->where('status = ?', STATUS_ENABLED)
				->query();
			if ( 1 === $result_page->numRows() ) {
				$page = $result_page->fetch();
				$this->title = $page['title'];
				$this->content = $page['content'];
			} else {
				$this->title = _('Page Not Found');
				$this->content = _('The page you are looking for can not be found by that name.');
			}

			$this->renderLayout('page');

		} catch ( Exception $e ) {

			PV::getLog()->addException($e);
			$this->_redirect($this->url('index/index'));

		}
	}

	public function contactusGet() {
		$this->contactus = array();
		$this->renderLayout('contactus');
	}

	public function contactusPost() {
		try {
			$contactus = (array)$this->getParam('contactus');

			$validator = $this->buildValidator();
			$validator->load('contactus')->setData($contactus)->validate();

			PV::getEmail()->setFrom($contactus['name'])
				->setFromName($contactus['email_address'])
				->send('contact-us', CONFIG_OWNER_EMAIL, array(
					'name' => asfw_safe($contactus['name']),
					'message' => asfw_safe($contactus['message'])
					)
				);

			$contactus['date_create'] = time();
			PV::getDb()->insert()->into('contact_us')->values($contactus)->query();

			$this->_getMessage()->pushSuccess(_('Your message was successfully submitted!'));
			$this->_redirect($this->url('index/index'));

		} catch ( Exception $e ) {

			PV::getLog()->addException($e);
			$this->_getMessage()->pushError(_('An error occurred when contacting us. Please try again.'));

		}

		$this->view->setValidator($validator);
		$this->contactus = $contactus;

		$this->renderLayout('contactus');
	}

	public function tourGet() {
		$this->renderLayout('tour');
	}
}