<?php

require_once 'application/Root/Root.php';

class Search_Controller extends Root_Controller {
	
	public function indexGet() {
		$query = $this->getParam('query');
		
		$vistaTokenizer = new Tokenizer();
		$token_list = $vistaTokenizer->tokenize($query);
		
		$token_list = array_keys($token_list);

		$paginator = PV::getPaginator();

		$search_result_count = 0;
		if ( count($token_list) > 0 ) {
			$search_zone = array(SEARCH_TYPE_QUERY, SEARCH_TYPE_LOCATION);
			$result_search = PV::getDb()->select()
				->from('search_index', 'si', 'si.user_id', 'SUM(si.weight*sz.weight) AS weight', 'u.*')
				->innerJoin('search_token', 'si.search_token_id', 'st.search_token_id')
				->innerJoin('search_zone', 'si.search_zone_id', 'sz.search_zone_id')
				->innerJoin('user', 'si.user_id', 'u.user_id')
				->inWhere('st.token', $token_list)
				->inWhere('sz.type', $search_zone)
				->where('u.status = ?', USER_STATUS_ENABLED)
				->where('u.type = ?', USER_TYPE_BUSINESS)
				->groupBy('si.user_id')
				->orderBy('weight', 'DESC')
				->query();
			$search_result_count = $result_search->numRows();

			$user_iterator = new Artisan_Db_Iterator($result_search, PV::getModel('user/business'));
			
			$this->search_list = $paginator->set($user_iterator)->get();
		}

		$this->paginator = $paginator;
		$this->search_result_count = $search_result_count;	
		$this->query = $query;
		$this->renderLayout('search-listing');
	}
	
	public function industryGet($industry_id, $type) {
		$paginator = PV::getPaginator();

		$type = intval($type);
		$industry_id = intval($industry_id);
		$result_industry = PV::getDb()->select()
			->from('industry')
			->where('industry_id = ?', $industry_id)
			->where('status = ?', STATUS_ENABLED)
			->query();
		$search_result_count = 0;
		$query = NULL;
		if ( 1 == $result_industry->numRows() ) {
			$industry = $result_industry->fetch();
			$query = _('Industry:') . ' ' . $industry['name'];
			if ( false === in_array($type, array(INDUSTRY_PRIMARY, INDUSTRY_SECOND, INDUSTRY_THIRD)) ) {
				$type = 1;
			}
			
			$user_id = vista_get_user()->getId();
			
			$field = 'industry'.$type;
			$select = PV::getDb()->select();
			$select->from('user')
				->where($field . ' = ?', $industry_id)
				->where('status = ?', USER_STATUS_ENABLED)
				->where('type = ?', USER_TYPE_BUSINESS);
		
			$result_search = $select->query();
			$search_result_count = $result_search->numRows();
			
			$user_iterator = new Artisan_Db_Iterator($result_search, PV::getModel('user/business'));
			$this->search_list = $paginator->set($user_iterator)->get();
		}
		
		$this->search_result_count = $search_result_count;
		$this->query = $query;
		$this->paginator = $paginator;
		
		$this->renderLayout('search-listing');
	}
}