<?php

function vista_selected($v1, $v2) {
	return ( $v1 == $v2 ? 'selected="selected"' : NULL );
}

function vista_checked($v1, $v2) {
	return ( $v1 == $v2 ? 'checked="checked"' : NULL );
}

function vista_date($timestamp, $offset=0) {
	$offset = ($offset * (60*60));
	return date(PHP_DATE_FORMAT_LONG, ($timestamp+$offset));
}

function vista_date_short($timestamp, $offset=0) {
	$offset = ($offset * (60*60));
	return date(PHP_DATE_FORMAT, ($timestamp+$offset));
}

function vista_first_time_day($time) {
	$string = date('Y', $time) . '-' . date('m', $time) . '-' . date('j', $time) . ' 00:00:00';
	return strtotime($string);
}

function vista_html_dropdown($name, $option_list, $selected=NULL, $title=NULL, $attr=NULL, $escape=true) {
	$view = PV::buildView();
	$view->name = $name;
	$view->option_list = $option_list;
	$view->title = $title;
	$view->selected = $selected;
	$view->attr = $attr;
	$view->escape = $escape;

	$html_dropdown = $view->render('root', 'html-dropdown');
	return $html_dropdown;
}

function vista_get_report_by_type($type_id) {
	$type_id = intval($type_id);
	$report = false;
	$result_report_type = PV::getDb()->select()
		->from('report_type')
		->where('report_type_id = ?', $type_id)
		->query();
	if ( 1 == $result_report_type->numRows() ) {
		$report = $result_report_type->fetch();
	}

	return $report;
}

function vista_get_param_list($ignore_list=array()) {
	$param_list = array();
	$ignore_list = asfw_make_values_keys($ignore_list);

	foreach ( $_GET as $k => $v ) {
		if ( false === array_key_exists($k, $ignore_list) ) {
			$param_list[$k] = $v;
		}
	}
	return $param_list;
}

function vista_get_param_list_string($ignore_list=array()) {
	$param_list = vista_get_param_list($ignore_list);
	$query_string = NULL;
	$len = count($param_list);
	$i=0;
	foreach ( $param_list as $k => $v ) {
		$query_string .= $k . "=" . $v;

		if ( $i < $len ) {
			$query_string .= "&amp;";
		}
		$i++;
	}

	$query_string = "?" . $query_string;
	return $query_string;
}

function vista_record_user_activity($type, $user_id, $profile_id) {
	$user_activity = PV::getModel('user/activity');
	$user_activity->setDateCreate(time())
		->setUserId((int)$user_id)
		->setProfileId((int)$profile_id)
		->setType($type)
		->setStatus(STATUS_ENABLED)
		->write();

	return true;
}