<?php

function vista_get_user() {
	return Artisan_Registry::pop('user');
}

function vista_user_authentication_login_hook($user) {
	if ( true === is_array($user) && count($user) > 0 ) {
		return true;
	}
	return false;
}

function vista_profile_image($user, $field) {
	$image = NULL;

	$user_data = array();
	if ( true === $user instanceof Model ) {
		$user_data = $user->get();
	} elseif ( true === is_array($user) ) {
		$user_data = $user;
	}

	$image_file = DIR_PRIVATE . er('content_directory', $user_data) . DS . er($field, $user_data);
	if ( true === is_file($image_file) ) {
		$image = PV::buildView()->img(asfw_safe(DS . $image_file));
	} else {
		$image = PV::buildView()->img(asfw_safe(DIR_IMAGE . 'no-profile-picture.png'));
	}

	return $image;
}

function vista_user_email_exists($email_address) {
	$result_email = PV::getDb()->select()
		->from('user')
		->where('email_address = ?', $email_address)
		->query();
	return ( 1 == $result_email->numRows() );
}

function vista_sanitize_username($username) {
	$username = preg_replace('/[^a-z0-9\.\_\-]*/i', NULL, $username);
	return $username;
}

function vista_username_exists($username) {
	$username = vista_sanitize_username($username);
	$result_username = PV::getDb()->select()
		->from('user')
		->where('username = ?', $username)
		->query();
	return ( 0 != $result_username->numRows() );
}

function vista_get_user_id_by_username($username) {
	$result_username = PV::getDb()->select('user_id')
		->from('user')
		->where('username = ?', $username)
		->query();
	$user_id = (int)$result_username->fetch('user_id');
	return $user_id;
}