<?php

class Paginator {
	private $_page = 0;
	private $_per_page = 0;
	private $_total = 0;
	
	private $_iterator = NULL;
	
	public function __construct() {
		$this->_per_page = 10;
	}
	
	public function set($iterator) {
		$this->_iterator = $iterator->fetch();
		return $this;
	}
	
	public function setPerPage($per_page) {
		$this->_per_page = intval($per_page);
		return $this;
	}
	
	public function get() {
		$page = intval(er('page', $_GET));
		$this->_page = ( 0 == $page ? 1 : $page );

		$this->_total = $this->_iterator->length();
		$this->_iterator->limit($this->_per_page)->page($this->_page);
		
		return $this->_iterator;
	}
	
	public function getPageList() {
		$view = PV::buildView();
		
		$page_last = ceil($this->_total / $this->_per_page);
		
		if ( $this->_page > $page_last ) {
			$this->_page = $page_last;
		}
		
		$view->page = $this->_page;
		$view->page_last = $page_last;
	
		return $view->render('root', 'paginator-link-list');
	}
}