<?php

class Report_Generator {
	private $_startTime = 0;
	
	const LIB_DIR_START = '..';
	
	public function __construct() {
		$this->_startTime = time();
	}
	
	public function __destruct() {
		
	}
	
	public function execute() {
		$db = PV::getDb();
		
		$result_report = $db->select()
			->from('report_type')
			->where('status = ?', STATUS_ENABLED)
			->query();
		if ( $result_report->numRows() > 0 ) {
			while ( $report = $result_report->fetch() ) {
				$filename = self::LIB_DIR_START . DS . DIR_LIB_OBJECT . DS . 'Report' . DS . 'Type' . DS . 'Generator' . DS . $report['filename'];
				if ( true === is_file($filename) ) {
					require_once $filename;
					$class = $report['generator_class'];
					if ( true === class_exists($class) ) {
						$report_obj = new $class($report['report_type_id'], $this->_startTime);
						$report_obj->execute();
					}
				}
			}
		}
		
		$db->update()->table('user_statistic')
			->set(array('processed' => STATISTIC_PROCESSED))
			->where('date_create < ?', $this->_startTime)
			->query();
		
		return true;
	}
}