<?php

abstract class Report_Type_Abstract {
	protected $_typeId = 0;
	protected $_userId = 0;
	protected $_startTime = 0;
	protected $_endTime = 0;
	
	public function __construct($start_time=0, $end_time=0) {
		$this->_startTime = intval($start_time);
		$this->_endTime = intval($end_time);
	}
	
	public function setTypeId($type_id) {
		$this->_typeId = intval($type_id);
		return $this;
	}
	
	public function setUserId($user_id) {
		$this->_userId = intval($user_id);
		return $this;
	}
	
	
	protected function _loadReportResult() {
		$result_report = PV::getDb()->select()
			->from('report')
			->where('user_id = ?', $this->_userId)
			->where('type_id = ?', $this->_typeId)
			->where('date_create >= ?', $this->_startTime)
			->where('date_create <= ?', $this->_endTime)
			->where('status = ?', STATUS_ENABLED)
			->orderBy('date_create', 'ASC')
			->query();
		return $result_report;
	}
	
	abstract public function getXml();
}