<?php

class Report_Type_Gender extends Report_Type_Abstract {
	
	public function getXml() {
		$report_data = $this->_getData();
		
		$xml = '<graph showNames="1" decimalPrecision="0">';
		if ( count($report_data) > 0 ) {
			$male = $report_data['male'];
			$female = $report_data['female'];
			$total = $male + $female;
			
			$xml .= '<set name="Male" value="' . $male . '" color="4a8cca" />';
			$xml .= '<set name="Female" value="' . $female . '" color="f49f37" />';
		}

		$xml .= '</graph>';
		echo $xml;
	}
	
	
	private function _getData() {
		$db = PV::getDb();
		$report_data = array();
		
		/* Get all reports for this user of this type. */
		$result_report = $this->_loadReportResult();
		if ( $result_report->numRows() > 0 ) {
			while ( $report = $result_report->fetch() ) {
				$result_report_data = $db->select()
					->from('report_data', 'rd')
					->where('report_id = ?', $report['report_id'])
					->query();
				
				while ( $type = $result_report_data->fetch() ) {
					$field = $type['field'];
					if ( false === isset($report_data[$field]) ) {
						$report_data[$field] = 0;
					}
					
					$report_data[$field] += $type['value'];
				}
			}
		}

		return $report_data;
	}
}