<?php

abstract class Report_Type_Generator_Abstract {
	protected $_typeId = 0;
	protected $_startTime = 0;
	protected $_startDate = NULL;

	protected $_startMonth = 0;
	protected $_startDay = 0;
	protected $_startYear = 0;
	
	public function __construct($type_id, $start_time) {
		$this->_typeId = intval($type_id);
		$this->_startTime = intval($start_time);
		
		$this->_startMonth = date('n', $this->_startTime);
		$this->_startDay = date('j', $this->_startTime);
		$this->_startYear = date('Y', $this->_startTime);
		
		$this->_startDate = $this->_startYear . '-' . $this->_startMonth . '-' . $this->_startDay . ' 00:00:00';
	}
	
	public function setTypeId($type_id) {
		$this->_typeId = intval($type_id);
		return $this;
	}
	
	abstract public function execute();
}