<?php

class Report_Type_Generator_Total extends Report_Type_Generator_Abstract {
	public function execute() {
		/**
		 * Because these are complex and not dealing with input data from an untrusted source,
		 * they're just gonna be raw sql.
		 */
		$sql = "SELECT u.user_id, us.user_statistic_id,
				FROM_UNIXTIME(us.date_create, '%Y-%m-%d 00:00:00') AS `date_string`
			FROM `user` `u`
			LEFT JOIN `user_statistic` `us`
				ON u.user_id = us.to_user_id
			WHERE (us.processed = '" . STATISTIC_UNPROCESSED . "')
				AND u.type = '" . USER_TYPE_BUSINESS . "'";
		$result_user = PV::getDb()->query($sql);

		$report_data = array();
		while ( $row = $result_user->fetch() ) {
			$user_id = intval($row['user_id']);
			$date_string = $row['date_string'];

			if ( true === empty($date_string) ) {
				$date_string = $this->_startDate;
			}

			$timestamp = strtotime($date_string);
			if ( false === isset($report_data[$user_id]) ) {
				$report_data[$user_id] = array();
			}

			if ( false === isset($report_data[$user_id][$timestamp]) ) {
				$report_data[$user_id][$timestamp] = 0;
			}

			$report_data[$user_id][$timestamp]++;
		}

		/**
		 * Intentionally done outside of the above loop so if it
		 * throws an exception, the loop doesn't exit without properly
		 * closing the database connection.
		 */
		$report = PV::getModel('report');
		$rdata = PV::getModel('report/data');

		foreach ( $report_data as $user_id => $data ) {
			foreach ( $data as $date_create => $total ) {
				/* Create a new report record. */
				$report_id = $report->setDateCreate($date_create)
					->setUserId($user_id)
					->setTypeId($this->_typeId)
					->setStatus(STATUS_ENABLED)
					->write();

				if ( $report_id > 0 ) {
					/* Create the data. */
					$rdata->setReportId($report_id)
						->setField('total')
						->setValue($total)
						->write();
				}

				$report->reset();
				$rdata->reset();
			}
		}
	}
}