<?php

class Report_Type_Total extends Report_Type_Abstract {

	public function getXml() {
		$report_data = $this->_getData();

		$xml = '<graph caption="Total Profile Views" xAxisName="Day" yAxisMinValue="0"
			yAxisName="Views" decimalPrecision="0" formatNumberScale="0"
			showNames="1" showValues="0" showAlternateHGridColor="1"
			AlternateHGridColor="ff5904" divLineColor="ff5904" divLineAlpha="20" animation="1"
			canvasBorderColor="666666"
			canvasBorderThickness="1"
			alternateHGridAlpha="5">';
		if ( count($report_data) > 0 ) {
			foreach ( $report_data as $data ) {
				$xml .= '<set name="' . date(PHP_DATE_FORMAT_SHORT, $data['time']) . '" value="' . $data['value'] . '" hoverText="Total Views" />';
			}
		}

		$xml .= '</graph>';
		echo $xml;
	}

	public function getJson() {
		$report_data = $this->_getData();
		return json_encode($report_data);
	}

	private function _getData() {
		$db = PV::getDb();

		/* Get all reports for this user of this type. */
		$report_data = array();
		$result_report = $this->_loadReportResult();
		if ( $result_report->numRows() > 0 ) {
			while ( $report = $result_report->fetch() ) {
				/* Get the data associated with this report. */
				$value = $db->select()
					->from('report_data', 'rd', 'rd.value')
					->where('report_id = ?', $report['report_id'])
					->query()
					->fetch('value');
				$value = intval($value);
				$report_data[] = array($report['date_create']*1000,$value);
			}
		}

		return $report_data;
	}
}