<?php

class Uploader_Video extends Uploader {
	private $_userId;
	
	public function setUserId($user_id) {
		$user_id = intval($user_id);
		if ( $user_id > 0 ) {
			$this->_userId = $user_id;
		}
		return $this;
	}
	
	public function upload() {
		$this->_createVideoName();
		return parent::upload();
	}
	
	private function _createVideoName() {
		$salt = substr(sha1($this->_fileName.time()), 0, 8);
		$video_name = $this->_userId . "_" . $salt . "_" . er('size', $this->_uploadData);
		$this->_fileName = $video_name;
	}
}