<?php

class User_Comment extends Model {
	
	public function getFromUserProfile() {
		return PV::getModel('user/profile', $this->getFromUserId());
	}
	
	public function getToUserProfile() {
		return PV::getModel('user/profile', $this->getToUserId());
	}
	
	public function getOwnerId() {
		return $this->getFromUserId();
	}
	
	public function isNew() {
		return ( $this->getStatus() == USER_COMMENT_NEW );
	}
	
	public function isApproved() {
		return ( $this->getStatus() == USER_COMMENT_APPROVED );
	}
	
	public function isDeclined() {
		return ( $this->getStatus() == USER_COMMENT_DECLINED );
	}
	
	public function belongsTo($user_id) {
		$user_id = intval($user_id);
		$to_user_id = intval($this->getToUserId());
		return ( $user_id === $to_user_id ? true : false );
	}
	
	protected function _insert() {
		if ( $this->getFromUserId() == $this->getToUserId() ) {
			$this->setStatus(USER_COMMENT_APPROVED);
		}
		
		return parent::_insert();
	}
}