<?php

class User_Consumer extends User {
	///< Artisan_Db_Iterator for a list of favorites.
	private $_favoriteList = NULL;
	
	public function __construct($id=0) {
		$this->reset();
		$this->setTable('user')->setPkey('user_id');
		$this->load($id);
	}
	
	public function getFavoriteList() {
		if ( NULL == $this->_favoriteList ) {
			$result_favorite = PV::getDb()->select()
				->from('user_favorite')
				->where('user_id = ?', $this->getId())
				->orderBy('date_create', 'DESC')
				->query();
			$this->_favoriteList = new Artisan_Db_Iterator($result_favorite, PV::getModel('user/favorite'));
		}
		$this->_favoriteList->rewind();
		return $this->_favoriteList;
	}
	
	public function sendWelcomeEmail() {
		PV::getEmail()->send('account-register-consumer', $this->getEmailAddress(), array('firstname' => $this->getFirstname()));
		return true;
	}
}