<?php

class User_Contact extends Model {
	public function getFromUserProfile() {
		return PV::getModel('user/profile', $this->getFromUserId());
	}
	
	public function getToUserProfile() {
		return PV::getModel('user/profile', $this->getToUserId());
	}
	
	public function getOwnerId() {
		return $this->getFromUserId();
	}
	
	public function isNew() {
		return ( $this->getStatus() == USER_CONTACT_NEW );
	}
	
	public function isApproved() {
		return ( $this->getStatus() == USER_CONTACT_APPROVED );
	}
	
	public function isDeclined() {
		return ( $this->getStatus() == USER_CONTACT_DECLINED );
	}
	
	public function isRelated() {
		return ( 1 == $this->getRelated() && true === $this->isApproved() );
	}
	
	public function belongsTo($user_id) {
		$user_id = intval($user_id);
		$to_user_id = intval($this->getToUserId());
		return ( $user_id === $to_user_id ? true : false );
	}
	
	protected function _insert() {
		if ( $this->getFromUserId() != $this->getToUserId() ) {
			return parent::_insert();
		}
		return false;
	}
	
	protected function _update() {
		if ( $this->getFromUserId() != $this->getToUserId() ) {
			return parent::_update();
		}
		return false;
	}
}