<?php

class User_Factory {
	public static function build($user_id) {
		$user_obj = NULL;
		$user_id = intval($user_id);
		$result_user = PV::getDb()->select()
			->from('user')
			->where('user_id = ?', $user_id)
			->query();
		if ( 1 == $result_user->numRows() ) {
			$user = $result_user->fetch();
			switch ( $user['type'] ) {
				case USER_TYPE_CONSUMER: {
					$user_obj = new User_Consumer($user_id);
					break;
				}

				case USER_TYPE_BUSINESS: {
					$user_obj = new User_Business($user_id);
					break;
				}
			}
		} else {
			$user_obj = new User_Generic();
		}

		return $user_obj;
	}
}