<?php

class User_Message extends Model {
	private $_childrenMessageList = NULL;
	private $_memberList = NULL;
	
	public function memberOf($user_id) {
		if ( true === $this->exists() ) {
			$user_count = PV::getDb()->select()
				->from('user_message_member')
				->where('user_message_id = ?', $this->getId())
				->where('user_id = ?', $user_id)
				->query()
				->numRows();
			return ( 1 == $user_count ? true : false );
		}
		return false;
	}
	
	public function addUser($user_id) {
		if ( false === $this->memberOf($user_id) ) {
			$message_member = PV::getModel('user/message/member');
			$message_member->setUserMessageId($this->getId())
				->setUserId($user_id)
				->write();
			return true;
		}
		return false;
	}
	
	public function getMemberList($force=false) {
		if ( NULL === $this->_memberList || true === $force ) {
			$result_member = PV::getDb()->select()
				->from('user_message_member')
				->where('user_message_id = ?', $this->getId())
				->query();
			$this->_memberList = new Artisan_Db_Iterator($result_member, PV::getModel('user/message/member'));
		}
		$this->_memberList->rewind();
		return $this->_memberList;
	}
	
	public function getChildrenMessageList($force=false) {
		if ( NULL === $this->_childrenMessageList || true === $force ) {
			$result_message = PV::getDb()->select()
				->from('user_message')
				->where('parent_id = ?', $this->getId())
				->where('status = ?', STATUS_ENABLED)
				->query();
			$this->_childrenMessageList = new Artisan_Db_Iterator($result_message, PV::getModel('user/message'));
		}
		$this->_childrenMessageList->rewind();
		return $this->_childrenMessageList;
	}
	
	
	
	public function getOwnerProfile() {
		return PV::getModel('user/profile', $this->getOwnerId());
	}
	
	public function getOwnerId() {
		return $this->getUserId();
	}
}