<?php

class User_Profile extends Model {
	
	public function __construct($id=0) {
		$this->reset();
		$this->setPkey('user_id')->setTable('user');
		$this->load($id);
	}

	public function enabled() {
		return ( true === $this->exists() && USER_STATUS_ENABLED == $this->getStatus() );
	}
	
	public function isComplete() {
		return ( USER_PROFILE_COMPLETE == $this->getComplete() ? true : false );
	}

	public function isUpgraded() {
		return ( 1 == $this->getUpgrade() ? true : false );
	}
	
	public function isBusiness() {
		return ( $this->getType() == USER_TYPE_BUSINESS );
	}
	
	public function isConsumer() {
		return ( $this->getType() == USER_TYPE_CONSUMER );
	}

	public function write() {
		return $this->_id;
	}
	
	protected function _insert() {
		return true;
	}
	
	protected function _update() {
		return true;
	}
	
	public function load($id) {
		if ( $id > 0 ) {
			$result = PV::getDb()->select()
				->from($this->_table)
				->where($this->_pkey . ' = ?', $id)
				->query();
			if ( 1 == $result->numRows() ) {
				$model = $result->fetch();
				
				$this->_model = $model;
				$this->_id = $id;
				return true;
			}
		}
		
		return false;
	}
}