<?php

class User_Session {
	private static $_instance = NULL;
	private $_user = array();

	const SESSION_USER = "_user";

	private function __construct() { }

	private function __clone() { }

	public static function get() {
		if ( true === is_null(self::$_instance) ) {
			self::$_instance = new self;
		}
		return self::$_instance;
	}

	public function setLogin($user_id) {
		$user_id = intval($user_id);
		if ( $user_id > 0 ) {
			Artisan_Session::get()->add(self::SESSION_USER, array(
				'user_id' => $user_id,
				'user_agent' => sha1(asfw_get_user_agent()),
				'status' => true
				)
			);
		}
		return true;
	}

	public function destroyLogin() {
		Artisan_Session::get()->remove(self::SESSION_USER);
		return true;
	}

	public function load() {
		$this->_user = (array)Artisan_Session::get()->from(self::SESSION_USER);

		if ( count($this->_user) > 0 ) {
			$user_agent_hashed_session = $this->_user['user_agent'];
			$user_agent_hashed = sha1(asfw_get_user_agent());

			if ( $user_agent_hashed_session != $user_agent_hashed ) {
				$this->destroyLogin();
			}
		}
		return true;
	}

	public function isLoggedIn() {
		if ( count($this->_user) > 0 ) {
			$user_id = intval(er('user_id', $this->_user));
			$status = er('status', $this->_user);

			if ( true === $status && $user_id > 0 ) {
				return true;
			}
		}
		return false;
	}

	public function getUserId() {
		$user_id = intval(er('user_id', $this->_user));
		return $user_id;
	}

}