#!/usr/bin/env php
<?php

$root_dir = realpath(dirname(__FILE__) . '/../');
$httpdocs = $root_dir . '/httpdocs/';
$library = $root_dir . '/lib/';
set_include_path('.:'.$httpdocs.':'.$library);

require_once 'configure.php';
require_once 'Object/PV.php';

PV::setDbConfig($config_artisan_db);
PV::setRouterConfig($config_artisan_router);
PV::init(true);

$db = Artisan_Registry::pop('db');

$db->query('TRUNCATE `search_index`');
$db->query('TRUNCATE `search_token`');

$zone_list = array();
$result_zone = $db->select()->from('search_zone')->query();
while ( $zone = $result_zone->fetch() ) {
	$zone_list[$zone['search_zone_id']] = $zone['field'];
}

$tokenizer = new Tokenizer();

$result_user = $db->select()
	->from('user')
	->where('status = ?', USER_STATUS_ENABLED)
	->query();
while ( $user = $result_user->fetch() ) {
	foreach ( $zone_list as $zone_id => $zone ) {
		$field_value = er($zone, $user);
		
		if ( false === empty($field_value) ) {
			$token_list = $tokenizer->tokenize($field_value);
		
			if ( count($token_list) > 0 ) {
				foreach ( $token_list as $token => $count ) {
					$search_token = PV::getModel('search/token');
					$token_id = $search_token->loadByToken($token)->setToken($token)->write();
					
					$weight = vista_get_token_weight($count);
					
					if ( $token_id > 0 ) {
						$search_index = array(
							'user_id' => $user['user_id'],
							'search_zone_id' => $zone_id,
							'search_token_id' => $token_id,
							'count' => $count,
							'weight' => $weight
						);
						
						$db->insert()
							->into('search_index')
							->values($search_index)
							->query();
					}
				}
			}
		}
	}
}

function vista_get_token_weight($value) {
	$start = 1;
	$total = 0;
	for ( $i=1; $i<=$value; $i++ ) {
		$total += $start;
		$start /= 2;
	}
	return $total;
}

$db->disconnect();
