<?php
/*
Newsboy
Exclusive to http://www.codecanyon.net
Coded by Davide Gaido
Contact: davide.0plus1@gmail.com
Url: http://www.0plus1.com/products/cc/newsboy
*/
class Newsboy {

	//-------------------------------------------------------------------------------------------------------
	//database options: (required)
	var $host = "localhost";
	var $user = "root";
	var $pass = "";
	var $db = "newsboy";
	var $table_pre = ''; //Table prefix
	//This is the absolute url to newsboy
	var $domain = "http://localhost/newsboy/"; //This option shouldn't be changed after using Newsboy. It's used to include the images in the articles.
	//Image upload section
	var $upload_dir = 'upload'; //Directory of the upload (do not change after using Newsboy)
	var $upload_dir_imgs = 'imgs'; //Directory for the images upload (do not change after using Newsboy)
	var $img_resize = true; //Auto-resize images?
	var $img_pixels = '400'; //If so, what is the larget size allowed
	var $img_quality = '85'; //Jpeg quality
	var $img_thumb_pre = 't_'; //Prefix for the thumbnails
	var $img_thumb_pixels = '80'; //Largest size dimension in pixels
	//Date format
	var $date_format = '%e %M %Y'; //The format in which the date will be outputted (http://dev.mysql.com/doc/refman/5.1/en/date-and-time-functions.html#function_date-format)
	//Maxwords indicator, the text that will be appended to trimmed articles
	var $maxwords_indicator = '...';
	var $debug = false; //Enable debug
	
	/* PAGINATION */
	var $items_for_page = '5'; //Items per pages
	
	//-------------------------------------------------------------------------------------------------------
	
	//Private
	var $page = false;
	var $limit = false;
	var $query_current_count = false;
	var $current_dir = false;
	
	function Newsboy(){
		$this->current_dir = dirname(__FILE__);
		$this->initSQL();
	}
	//
	function getCategories(){
		$sql = "SELECT id, name, DATE_FORMAT(date, '".$this->date_format."') as newdate FROM ".$this->table_pre."categories AS categories ORDER BY id";
		$items = mysql_query($sql) or die("Database Error: ".mysql_error());
		
		while ($obj = mysql_fetch_object($items)) {
        	$array[$obj->id]['id'] = $obj->id;
            $array[$obj->id]['name'] = $obj->name;
			$array[$obj->id]['newdate'] = $obj->newdate;
        }
		
		mysql_free_result($items);
		
		return $array;
	}
	//
	function getDates($year=false){
		
		$sql = "SELECT id, DATE_FORMAT(articles.date, '%M') as month, DATE_FORMAT(articles.date, '%Y') as year FROM ".$this->table_pre."articles AS articles GROUP BY YEAR(articles.date), MONTH(articles.date) ORDER BY articles.date DESC;";
		$items = mysql_query($sql) or die("Database Error: ".mysql_error());
		
		while ($obj = mysql_fetch_object($items)) {
			$array[$obj->year][]['month'] = $obj->month;
        }
		
		mysql_free_result($items);
		
		return $array;
		
	}
	//
	function getArticle($id){
		$sql = "SELECT articles.id,articles.cat_id,articles.title,articles.text,DATE_FORMAT(articles.date, '".$this->date_format."') as newdate, categories.name as cat_name, users.name as author FROM ".$this->table_pre."articles AS articles";
		$sql .= " JOIN ".$this->table_pre."categories AS categories on categories.id = articles.cat_id ";
		$sql .= " JOIN ".$this->table_pre."users AS users on users.id = articles.u_id ";
		$sql .= " WHERE articles.id='$id'";
		$sql .= " LIMIT 1;";
    	$result = mysql_query($sql) or die(mysql_error());
		$row = mysql_fetch_array($result);
		return $row;
	}
	//
	function getArticles($cat_id=false,$date=false){
		
		$sql = "SELECT articles.id,articles.cat_id,articles.title,articles.text,DATE_FORMAT(articles.date, '".$this->date_format."') as newdate, categories.name as cat_name, users.name as author, image FROM ".$this->table_pre."articles AS articles ";
		$sql .= "JOIN ".$this->table_pre."categories as categories on categories.id = articles.cat_id ";
		$sql .= "JOIN ".$this->table_pre."users AS users on users.id = articles.u_id ";
		
		if ($cat_id) { 
			$sql .= "WHERE cat_id='$cat_id' "; 
		} elseif (is_array($date) && $date!=false) { 
			$sql .= "WHERE DATE_FORMAT(articles.date, '%Y %M') = '".$date['Y']." ".$date['M']."' ";
		} else {
			$sql .= "WHERE cat_id IS NOT NULL "; 
		}
		
		$sql .= "ORDER by articles.date DESC ";
		//Adds a limit to the query
		if (($this->page !== false)&&($this->limit !== false)) {
			$sql .= $this->addLimit();
		}
		//
		$items = mysql_query($sql) or die("Database Error: ".mysql_error());
		//Populate the array
		while ($obj = mysql_fetch_object($items)) {
        	$array[$obj->id]['id'] = $obj->id;
            $array[$obj->id]['cat_id'] = $obj->cat_id;
			$array[$obj->id]['title'] = $obj->title;
            $array[$obj->id]['text'] = $obj->text;
			$array[$obj->id]['newdate'] = $obj->newdate;
            $array[$obj->id]['cat_name'] = $obj->cat_name;
			$array[$obj->id]['author'] = $obj->author;
			$array[$obj->id]['image'] = $obj->image;
        }
		
		mysql_free_result($items);
		if ($this->debug=='1') {
			echo 'LIMIT: '.$this->page.' '.$this->limit .'<br/>';
			echo 'QUERY: '.$sql.'<br>';
			print_r($array);
		}
		
		$this->query_current_count = count($array);
		
		return $array;
	}
	//Automagically prints the article
	function printArticle($text,$max_words=false,$img_strip=false,$tags_strip=false){
		$text = html_entity_decode($text,ENT_QUOTES,'UTF-8');
		if($img_strip===true){
			$text = $this->stripIMG($text);
		}
		if($tags_strip===true){
			$text = $this->stripTAGS($text);
		}
		if(is_int($max_words)){
			$text = $this->maxWords($text,$max_words);
		}
		return $text;
	}
	//Automagically prints the title
	function printTitle($string){
		return html_entity_decode($string,ENT_QUOTES,'UTF-8');
	}
	/*
		PAGINATION
	*/
	function initPagination($page=false){
		if ($page) {
			$page = $page;
		} else {
			$page = 0;
		}
		//
		$page = intval($page);
		$this->page = $page;
		$items_for_page = intval($this->items_for_page);
		$this->limit = $page*$items_for_page;
	}
	//
	function pagination(){
				
		$next = $this->page+1;
		$prev = $this->page-1;
		
		$return = array();
		//We need to preserve all the GETS
		if(isset($_GET['cat_id'])){
			$get = '&cat_id='.$_GET['cat_id'];
			$rows = $this->countArticles($_GET['cat_id']);
		} else if (isset($_GET['M'])&&isset($_GET['Y'])){
			$get = '&M='.$_GET['M'].'&Y='.$_GET['Y'];
			$rows = $this->countArticles(false,$_GET);
		} else {
			$get = false;
			$rows = $this->countArticles();
		}
		//Previous page
		if($this->page>0) {
			$html_prev = '<a href="'.$_SERVER['PHP_SELF'].'?page='.$prev.$get.'"><img src="'.$this->domain.'lib/icons/arrow_left.png" /></a>';
			$return['prev'] = $html_prev;
		} else {
			$return['prev'] = false;
		}
		//Next page
		if (( ($this->page*$this->items_for_page)+$this->query_current_count ) < $rows) {
			$html_next = '<a href="'.$_SERVER['PHP_SELF'].'?page='.$next.$get.'"><img src="'.$this->domain.'lib/icons/arrow_right.png" /></a>';
			$return['next'] = $html_next;
		}
		else {
			$return['next'] = false;
		}
		if($this->debug===true){
			echo $this->page.'-'.$this->items_for_page.'-'.$this->query_current_count.'-'.$rows;
		}
		return $return;
		
	}
	/*
		PRIVATE
	*/
	function initSQL(){
		mysql_connect($this->host,$this->user,$this->pass);
		mysql_select_db($this->db) or die("Database Error: ".mysql_error());
	}
	//Replaces all images in the article
	function stripIMG($string){
		return preg_replace("/<img[^>]+\>/i", "", $string);
	}
	//Replaces all tags in the article
	function stripTAGS($string){
		$stripped = strip_tags($string,'<p><a><strong><em>');
		return $stripped;
	}
	//
	function maxWords($string, $count){
		$words = explode(' ', $string);
		if (count($words) > $count){
			array_splice($words, $count);
			$string = implode(' ', $words);
			$string .= ' '.$this->maxwords_indicator;
		}
		return $string;
	}
	//
	function addLimit(){
		$query = ' LIMIT '.$this->limit.', '.$this->items_for_page.';';
		return $query;
	}
	//
	function countArticles($cat_id=false,$date=false){
		$sql = "SELECT count(id) AS num_rows FROM ".$this->table_pre."articles AS articles ";
		if ($cat_id) { 
			$sql .= "WHERE cat_id='$cat_id' "; 
		} elseif (is_array($date) && $date!=false) { 
			$sql .= "WHERE DATE_FORMAT(articles.date, '%Y %M') = '".$date['Y']." ".$date['M']."' ";
		} else {
			$sql .= "WHERE cat_id IS NOT NULL "; 
		}
		$sql .=  " LIMIT 1;";
    	$result = mysql_query($sql) or die(mysql_error());
		$row = mysql_fetch_array($result);
		return $row['num_rows'];
	}
	/*
	IMAGE ?
	*/
	function makeLink($filename){
		$return = '<img src="'.$this->domain.'upload/imgs/'.$filename.'" alt="'.$filename.' />';
		return $return;
	}
	//
	function cleanInput($string){
		return strip_tags(trim($string));
	}
	
}

?>