<?php

// Open logfile
$_GET['file'] = empty($_GET['file']) ? date("Ymd") : $_GET['file'];
if(!empty($_GET['file']) && is_numeric($_GET['file'])){
	$cachedir = str_replace("\\", "/", dirname(__FILE__)) . "/cache/";
	$cachefile = $cachedir . $_GET['file'] . ".log";
	if(file_exists($cachefile)){ 
		$errors = json_decode(file_get_contents($cachefile));
	}
}

// Error type strings
$numbererrors = array(
							    E_ERROR          	=> 'Error',
							    E_WARNING        	=> 'Warning',
							    E_PARSE          	=> 'Parsing Error',
							    E_NOTICE          	=> 'Notice',
							    E_CORE_ERROR      	=> 'Core Error',
							    E_CORE_WARNING    	=> 'Core Warning',
							    E_COMPILE_ERROR  	=> 'Compile Error',
							    E_COMPILE_WARNING 	=> 'Compile Warning',
							    E_USER_ERROR      	=> 'User Error',
							    E_USER_WARNING    	=> 'User Warning',
							    E_USER_NOTICE    	=> 'User Notice',
							    E_STRICT          	=> 'Runtime Notice');

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Logger Server</title>
<script language="javascript" type="text/javascript">
function openLog(file){
	document.location.href = '<?php echo htmlspecialchars($_SERVER['PHP_SELF']) ?>?file=' + file;	
}
</script>
<style>
body{
	color:#333333;
	font-family:Arial,sans-serif;
	text-align: center;	
	background-color: #e1eaf3;
	font-size:12px;
}
#wrapper{
	margin: 0 auto;
	text-align: left;
	padding: 30px;
	width: 700px;
	border:1px solid #97AEC9;
	background-color: #FFF;
	-moz-border-radius-bottomleft:6px;
	-moz-border-radius-bottomright:6px;
	-moz-border-radius-topleft:6px;
	-moz-border-radius-topright:6px;
}
h2{
	padding: 0px;
	margin: 0px 0px 5px 0px;
	font-size: 16px;
}
table p{
	margin: 0px;
	padding: 0px 0px 2px 0px;
}
.log1, .log2, .log4, .log8, .log16, .log32, .log64, .log128, .log256, .log512, .log1024, .log2048 {
	color:#636363;
	font-size:0.92em;
	margin:6px 0;
	padding:20px;
}
.log1, .log16, .log64, .log256 {
	background-color:#FFEDEF;
	border:1px solid #FF7586;
}
.log2, .log32, .log128, .log512 {
	background-color:#FDE8D9;
	border:1px solid #F7BF88;
}
.log8, .log1024 {
	background-color:#FFFECC;
	border:1px solid #FAECB5;
}
.log4 {
	background-color:#DFE3FF;
	border:1px solid #7081F5;
}
.log2048 {
	background-color:#E2F9E3;
	border:1px solid #9ECE9E;
}

.logger1 td, .logger16 td, .logger64 td, .logger256 td{
	border-bottom:1px solid #DFDFDF;
	border-top: 6px solid #FF7586;
	background-color:#FFEDEF;
	padding: 10px;
}
.logger2 td, .logger32 td, .logger128 td, .logger512 td{
	border-bottom:1px solid #DFDFDF;
	border-top: 6px solid #F7BF88;
	background-color:#FDE8D9;
	padding: 10px;
}
.logger8 td, .logger1024 td{
	border-bottom:1px solid #DFDFDF;
	border-top: 6px solid #FAECB5;
	background-color:#FFFECC;
	padding: 10px;
}
.logger4 td{
	border-bottom:1px solid #DFDFDF;
	border-top: 6px solid #7081F5;
	background-color:#DFE3FF;
	padding: 10px;
}
.logger2048 td{
	border-bottom:1px solid #DFDFDF;
	border-top: 6px solid #9ECE9E;
	background-color:#E2F9E3;
	padding: 10px;
}
.small{
	font-size: 11px;	
}
</style>
</head>

<body>
<div id="wrapper">
<h1>Logger Server</h1>
<label for="select"></label>
<label for="sltfile">Select a date</label>
<select name="sltfile" id="sltfile" onchange="openLog(this.value);">
<?php
$dir_handle = @opendir($cachedir) or die("Unable to open $path");
while ($file = readdir($dir_handle)) 
{
	if($file != "." && $file != ".."){
		$year = substr($file, 0, 4);
		$month = substr($file, 4, 2);
		$day = substr($file, 6, 2);
?>
	<option value="<?php echo substr($file,0, 8) ?>"><?php echo $year . '/' . $month . '/' . $day ?></option>
<?php
	}
}
?>
</select>
<a href="#" onclick="javascript:openLog('<?php echo date('Ymd') ?>');">Today</a>

<?php if(file_exists($cachefile)){ ?>
<table width="100%" border="0" cellpadding="0" cellspacing="2">
  <?php foreach($errors as $error){ ?>
  <tr class="logger<?php echo $error->type ?>">
    <td><h2><?php echo $error->host; ?></h2><p><?php echo htmlspecialchars($error->message); ?></p></td>
    <td colspan="2" class="small"><strong>File:</strong> <?php echo htmlspecialchars($error->file); ?><br />
      <strong>Line:</strong> <?php echo $error->line; ?><br />
      <strong>IP:</strong> <?php echo $error->ip; ?><br />
      <strong>URL:</strong> <?php echo htmlspecialchars($error->url); ?><br />
      <strong>Type:</strong> <?php echo $numbererrors[$error->type]; ?><br />
      <strong>Date:</strong> <?php echo htmlspecialchars($error->date); ?></td>
    </tr>
    <?php } ?>
</table>
<?php }else{ ?>
	No logfile found.
<?php } ?>
</div>
</body>
</html>