<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
| 	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	http://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are two reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['scaffolding_trigger'] = 'scaffolding';
|
| This route lets you set a "secret" word that will trigger the
| scaffolding feature for added security. Note: Scaffolding must be
| enabled in the controller in which you intend to use it.   The reserved 
| routes must come before any wildcard or regular expression routes.
|
*/

$route['default_controller'] = "welcome";
$route['scaffolding_trigger'] = "";

$route['top'] = "welcome/index/top"; 

$route['questions'] = "feedback/display/questions";
$route['questions/top/(:num)'] = "feedback/display/questions/$1/top";
$route['questions/(:num)'] = "feedback/display/questions/$1";
$route['question/v/(:num)'] = "feedback/view/questions/$1";

$route['ideas'] = "feedback/display/ideas";
$route['ideas/top/(:num)'] = "feedback/display/ideas/$1/top";
$route['ideas/(:num)'] = "feedback/display/ideas/$1";
$route['idea/v/(:num)'] = "feedback/view/ideas/$1";

$route['problems'] = "feedback/display/problems";
$route['problems/top/(:num)'] = "feedback/display/problems/$1/top";
$route['problems/(:num)'] = "feedback/display/problems/$1";
$route['problem/v/(:num)'] = "feedback/view/problems/$1";

$route['praise'] = "feedback/display/praise";
$route['praise/top/(:num)'] = "feedback/display/praise/$1/top";
$route['praise/(:num)'] = "feedback/display/praise/$1";
$route['praise/v/(:num)'] = "feedback/view/praise/$1";


/* End of file routes.php */
/* Location: ./system/application/config/routes.php */