/*
 * jQuery Simple Tooltip Plugin
 * Version: 1.0
 *
 * Author: Chris Rivers
 * http://chrisriversdesign.com
 *
 *
 * Changelog: 
 * Version: 1.0
 *
 */
jQuery.fn.simpleToolTip = function (options) {

    var settings = { // Defaults
        'orientation': 'left',
        'element': 'ul.expertise li'
    };

    return this.each(function () {
        // If options exist, lets merge them
        // with our default settings
        if (options) {
            $.extend(settings, options);
        }

        $(settings.element).hover(

        function () { // hover functionality
            var tooltipHtml = '<div class=\"tooltip-widget simple-tooltip\">';
            tooltipHtml += '<div class=\"tooltip-widget-top\"></div>';
            tooltipHtml += '<div class=\"tooltip-widget-middle\">';
            tooltipHtml += '<p></p>';
            tooltipHtml += '</div>';
            tooltipHtml += '<div class=\"tooltip-widget-bottom\"></div>'
            tooltipHtml += '</div>';

            $('body').append(tooltipHtml);

            var tooltipContent;
            var position;

            if (settings.orientation == 'right') {
                var offset = $(this).width();
                position = $(this).position();
                position.left = position.left + offset;

                $('.simple-tooltip').addClass('right');

            } else { // Left Functionality
                position = $(this).position();
                position.left = position.left - 222;
            }

            if ($(this).attr('tooltip') == '' || $(this).attr('tooltip') == null) {
                // Do nothing because tooltip content doesn't exist
            } else {
                var tooltipContent = $(this).attr('tooltip');

                $(".tooltip-widget.simple-tooltip p").html(tooltipContent);

                var heightOffset = ($(".tooltip-widget.simple-tooltip").height()) / 2;
                position.top = (position.top - heightOffset) + 3;

                $(".tooltip-widget.simple-tooltip").show().css({
                    'position': 'absolute',
                    'left': position.left,
                    'top': position.top,
                    'display': 'inline-block'
                });
            }
        }, function () {
            // hover out functionality
            $('.tooltip-widget.simple-tooltip').remove();
        });

    });

    return this;
}