<?php
/* Get the query string "q" variable -- this is what the user typed in. */
$q = $_GET['q'];

/* Run some sort of searching operation.
			- Usually you will be searching a database and then pulling back results.
			- In this case, we're going to just use a simple array as our data source and find any matches. */
include('sample_data.php');
$results = array('fruits' => array(), 'vegetables' => array());
foreach ($fruits as $name => $data)
{
	if (stripos($name, $q) !== false)
	{
		$results['fruits'][$name] = $data;
	}
}
foreach ($vegetables as $name => $data)
{
	if (stripos($name, $q) !== false)
	{
		$results['vegetables'][$name] = $data;
	}
}

/* Get the data into a format that Smart Suggest will read (see documentation). */
$final_fruits = array('header' => array(), 'data' => array());
$final_fruits['header'] = array(
																		'title' => 'Fruits',										# Appears at the top of this category
																		'num' => count($results['fruits']),			# Displayed as the total number of results.
																		'limit' => 5														# An arbitrary number that you want to limit the results to.
																	);
foreach ($results['fruits'] as $name => $data)
{
	$final_fruits['data'][] = array(
														'primary' => $name,																							# Title of result row
														'secondary' => $data['description'],														# Description below title on result row
														'image' => $data['image'],																			# Optional URL of 40x40px image
														'onclick' => 'alert(\'You clicked on the '.$name.' fruit!\');',	# JavaScript to call when this result is clicked on
														'fill_text' => strtolower($name)																		# Used for "auto-complete fill style" example
													);
}

$final_vegetables = array('header' => array(), 'data' => array());
$final_vegetables['header'] = array(
																		'title' => 'Vegetables',										# Appears at the top of this category
																		'num' => count($results['vegetables']),			# Displayed as the total number of results.
																		'limit' => 5																# An arbitrary number that you want to limit the results to.
																	);
foreach ($results['vegetables'] as $name => $data)
{
	$final_vegetables['data'][] = array(
														'primary' => $name,																									# Title of result row
														'secondary' => $data['description'],																# Description below title on result row
														'image' => $data['image'],																					# Optional URL of 40x40px image
														'onclick' => 'alert(\'You clicked on the '.$name.' vegetable!\');',	# JavaScript to call when this result is clicked on
														'fill_text' => strtolower($name)																		# Used for "auto-complete fill style" example
													);
}

/* Output JSON */
$final = array($final_fruits, $final_vegetables);
header('Content-type: application/json');
echo json_encode($final);
die();
?>