<?php
/*
	Smooth Feed
	Author: <Denon Studio>
	Published: 200905 :: Denon Studio via ThemeForest.com
*/

include_once("SimplePie/simplepie.inc");
include_once("Feed_Config.php"        );

$TEMPORARY_FOLDER = "temp";
$DATETIME_FORMAT  = "Y-m-j g:i:s a";
$ONE_HOURE        = 60 * 60;

class Feed_Manager {

    var $config;
    var $allFeeds;

    public function __construct() {
        $this->config = new Feed_Config();
        $this->createCacheFolder();
    }    

    public function __destruct() {
        unset($config);
        $config = null; 
    }
    
    public function createCacheFolder() {
        if (!file_exists($GLOBALS["TEMPORARY_FOLDER"])) {
            mkdir($GLOBALS["TEMPORARY_FOLDER"], 0777);
        }
    }
    
    public function getFeedData() {

        $urls = $this->config->getFeedURLs();
        $str  = "";
        foreach ($urls as $url) {
            if (strcmp($str,"") != "")
                $str .= ",";

            $parser = new SimplePie($url, $GLOBALS["TEMPORARY_FOLDER"], $GLOBALS["ONE_HOURE"] * 3);
            $parser->init();
            $parser->handle_content_type();

            $items = $parser->get_items();
            $str .= $this->toJSON($items);

            $parser->__destruct();
            unset($parser);
        }

        return "[" . $str . "]";
    }
    

    private function getRssItems($file) {
        $this->parser->loadRSS($file);
        return $this->parser->getItems(); 
    }
    
    private function toJSON($items) {
        $result = "";

        for ($i = 0; $i < count($items); $i++) {
            if ($i != 0)
                $result .= ",";

            $item    = $items[$i];
            $link    = $item->get_link();
            $title   = $item->get_title();
            $result .= "{\"link\" : \"$link\", \"title\" : \"$title\" }";
        }

        return $result;
    }
}

header("content-type: text/plain; charset=UTF-8");

$manager = new Feed_Manager();
echo $manager->getFeedData();
$manager->__destruct();
unset($manager);
$manager = null;

?>