-- -------------- PAY ATTENTION ON THE TABLE PREFIX----------------

-- 
-- Tabellenstruktur fr Tabelle `customer_users`
-- 

CREATE TABLE `customer_users` (
  `id` int(11) NOT NULL auto_increment,
  `custid` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  `created` datetime NOT NULL,
  `created_by` varchar(20) NOT NULL,
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `customers`
-- 

CREATE TABLE `customers` (
  `id` int(11) NOT NULL auto_increment,
  `custno` varchar(20) default NULL,
  `descr` varchar(200) NOT NULL COMMENT 'company',
  `contact_person` varchar(100) default NULL,
  `zip` varchar(15) default NULL,
  `location` varchar(70) default NULL,
  `address` varchar(150) default NULL,
  `country` varchar(50) default NULL,
  `email` varchar(100) default NULL,
  `url` varchar(100) default NULL,
  `tel1` varchar(50) default NULL,
  `tel2` varchar(50) default NULL,
  `fax` varchar(50) default NULL,
  `descr_long` text,
  `status` tinyint(1) NOT NULL default '1',
  `created` datetime NOT NULL,
  `created_by` varchar(20) NOT NULL,
  `edited` datetime default NULL,
  `edited_by` varchar(20) default NULL,
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `docs`
-- 

CREATE TABLE `docs` (
  `id` int(11) NOT NULL auto_increment,
  `custid` int(11) NOT NULL,
  `descr` varchar(150) NOT NULL,
  `file_name` varchar(150) NOT NULL,
  `file_type` varchar(150) default NULL,
  `created` datetime NOT NULL,
  `edited` datetime default NULL,
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `pdocs`
-- 

CREATE TABLE `pdocs` (
  `id` int(11) NOT NULL auto_increment,
  `pid` int(11) NOT NULL,
  `descr` varchar(150) NOT NULL,
  `file_name` varchar(150) NOT NULL,
  `file_type` varchar(150) default NULL,
  `created` datetime NOT NULL,
  `edited` datetime default NULL,
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `project_times`
-- 

CREATE TABLE `project_times` (
  `id` int(11) NOT NULL auto_increment,
  `pid` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  `task_id` int(11) default '0',
  `short_comment` varchar(200) NOT NULL,
  `comment` text,
  `start` datetime NOT NULL,
  `end` datetime default NULL,
  `milestone` tinyint(1) NOT NULL default '0',
  `created` datetime NOT NULL,
  `created_by` varchar(20) NOT NULL,
  `edited` datetime default NULL,
  `edited_by` varchar(20) default NULL,
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `project_users`
-- 

CREATE TABLE `project_users` (
  `id` int(11) NOT NULL auto_increment,
  `pid` int(11) NOT NULL,
  `uid` int(11) NOT NULL,
  `created` datetime NOT NULL,
  `created_by` varchar(20) NOT NULL,
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `projects`
-- 

CREATE TABLE `projects` (
  `id` int(11) NOT NULL auto_increment,
  `custid` int(11) NOT NULL,
  `descr` varchar(200) NOT NULL,
  `descr_long` text,
  `status` tinyint(1) NOT NULL default '1',
  `created` datetime NOT NULL,
  `created_by` varchar(20) NOT NULL,
  `edited` datetime default NULL,
  `edited_by` varchar(20) default NULL,
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `todos`
-- 

CREATE TABLE `todos` (
  `id` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL,
  `pid` int(11) NOT NULL,
  `custid` int(11) NOT NULL,
  `delegated_uid` int(11) default NULL,
  `descr` varchar(150) NOT NULL,
  `descr_long` text,
  `status` tinyint(1) NOT NULL default '0',
  `created` datetime NOT NULL,
  `edited` datetime default NULL,
  `opened` datetime default NULL,
  PRIMARY KEY  (`id`)
);

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `users`
-- 

CREATE TABLE `users` (
  `id` int(11) NOT NULL auto_increment,
  `user` varchar(20) NOT NULL,
  `pass` varchar(50) NOT NULL,
  `realname` varchar(50) default NULL,
  `email` varchar(100) default NULL,
  `comment` text,
  `deleteable` tinyint(1) NOT NULL default '1',
  `userlevel` tinyint(4) NOT NULL default '0' COMMENT '0..custom,2..admin',
  `acl_p_add_ass` tinyint(1) NOT NULL default '0',
  `acl_p_add_all` tinyint(1) NOT NULL default '0',
  `acl_p_view_ass` tinyint(1) NOT NULL default '0',
  `acl_p_view_all` tinyint(1) NOT NULL default '0',
  `acl_p_view_ass_c` tinyint(1) NOT NULL default '0',
  `acl_t_view_own` tinyint(1) NOT NULL default '0',
  `acl_c_view_ass` tinyint(1) NOT NULL default '0',
  `acl_c_view_all` tinyint(1) NOT NULL default '0',
  `acl_pf_view` tinyint(1) NOT NULL default '0',
  `acl_pf_add` tinyint(1) NOT NULL default '0',
  `acl_pf_admin` tinyint(1) NOT NULL default '0',
  `weekly_load` int(11) default NULL,
  `monthly_load` int(11) default NULL,
  `status` tinyint(1) NOT NULL default '1',
  `created` datetime NOT NULL,
  `created_by` varchar(20) NOT NULL,
  `edited` datetime default NULL,
  `edited_by` varchar(20) default NULL,
  PRIMARY KEY  (`id`)
);

INSERT INTO `users` (`id`, `user`, `pass`, `realname`, `email`, `comment`, `deleteable`, `userlevel`, `status`, `created`, `created_by`, `edited`, `edited_by`) VALUES 
(1, 'admin', password('pass'), '', '', '', 0, 2, 1, '2009-07-29 15:31:50', 'mac', NULL, NULL);


-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle log`
-- 

CREATE TABLE `log` (
  `id` int(11) NOT NULL auto_increment,
  `cat` varchar(20) default NULL,
  `cat_id` int(11) default NULL,
  `descr_short` varchar(150) default NULL,
  `descr_long` text,
  `uid` int(11) default NULL,
  `uname` varchar(50) default NULL,
  `created` datetime default NULL,
  PRIMARY KEY  (`id`)
);