<?php

/*
 * jtwCore.php
 * Defines functions which involve shared/re-usable JTW classes and frameworks.
 */

if (!defined('in_jtwSpinner')) die('This file cannot be accessed directly.');

/*
 * jtwSpinner_menu()
 * Checks if global JTW menu exists, and if not, registers it.
 * Adds relevant menu items to JTW menu.
 */

if (!function_exists('jtwSpinner_menu')) {
	function jtwSpinner_menu() { 
		global $jtwSpinner_pluginURL;
		
		if (!defined('jtw_menu_setup')) {
			// Create the menu
			
			$icon = $jtwSpinner_pluginURL . 'images/icon.ico';
			                                                                
			if (function_exists('add_object_page')) {
			    add_object_page( 'Just The Web Plugins', 'Just The Web', 'manage_options', 'jtw', 'jtwCore_menu', $icon);	
			} else {
        		add_menu_page( 'Just The Web Plugins', 'Just The Web', 'manage_options', 'jtw', 'jtwCore_menu', $icon);
			}
			
			define('jtw_menu_setup', true);
		}    
		
		// Add the subpages we need
		add_submenu_page('jtw', 'Spinner - Settings', 'Spinner', 'manage_options', 'jtw-extended-options', 'jtwspin_admin');
	}
	add_action('admin_menu', 'jtwSpinner_menu');
}

/*
 * jtwCore_menu()
 * A standard menu to give support and contact information for plugins.
 */

if (!function_exists('jtwCore_menu')) {
	function jtwCore_menu() {
		?>
		<div class="wrap">

			<div id="icon-options-general" class="icon32">
				<br />
			</div>

			<h2>Just The Web Plugins</h2>

			<p>Here we can publish information about our plugins, etc.</p>

		</div>
		<?php
	}
}

